;---------------------------------------------------------------------
; GRUND 3.0, das 30 Jahre Revival - Andreas Rohmann
;---------------------------------------------------------------------

	;*****************************************
	;* Grundprogramm   version 2.0           *
	;* (C) 1983  by Rolf-Dieter Klein        *
	;* 830521  1.0                           *
	;* 830711  1.1                           *
	;* 830815  1.2 rufe... schreite16tel     *
	;* 830916  1.3 RAM-Variable              *
	;* 831009  1.4 Gross/Klein als Eingabe   *
	;* 831014  1.5 F=Flip eingebaut          *
	;* 831021  1.6 IGBN aus expr entfernt    *
	;*             fehler HEBE,SENKE bes.    *
	;* 831031  2.0 INT,NMI                   *
	;*****************************************
	;* 131129  3.0 Neucodierung 30 Jahre NKC *
	;*             www.ndr-nkc.de            *
	;* 171114  3.1 Anpassungen fr Assembler *
	;*****************************************

;---------------------------------------------------------------------
; 20131102	Platzeinsparungen, absolute Sprnge entfernt
; 20131103	Einseitenmen, Optische Anpassungen
; 20131105	Verbesserter Hexdump
; 20131106	Weitere Optimierungen, Codekrzungen
; 20131108	Verbessert Symbolausgabe, Symbolhandling
; 20131109	Rcksprung FLOMON, vergrerte Buffer
; 20131122	Low Level SPI Routinen
; 20131123	USB Directory
; 20131124	Load USB, Save USB
; 20131125	Sprachuntersttzung deutsch / englisch
; 20131126	Weitere Optimierungen, Autoflip optional
; 20131127	berarbeitung Kommentare
; 20131129	Tests
; 20171114	Anpassungen fr Assembler/Disassembler ROM
; 20171115	Optional Menpunkte fr GOSI, BASIC, EZASS
;---------------------------------------------------------------------


;---------------------------------------------------------------------
; COMPILERSCHALTER
;---------------------------------------------------------------------
; ORIGIN: 0000h fr Einsatz ohne Bankboot auf ROA64
;	  0000h fr Einsatz auf Bankboot erster Sockel
;	  2000h fr Einsatz auf Bankboot zweiter Sockel

base0000	.equ	0000h
base2000	.equ	2000h
optBASE		.equ	base0000

; Einstellung Sprache
langDE		.equ	1	; Sprache auf deutsch einstellen
langEN		.equ 	2	; Sprache auf englisch einstellen
optLANG		.equ	langDE

; Untersttzung CAS oder IOE&VDIP1
saveNONE	.equ	0	; Keine Routinen zum Speichern einbinden
saveCAS		.equ 	1	; Save Load Verify mit CAS
saveUSB		.equ	2	; Save Load Dir mit IOE und VDIP1
optSAVE		.equ	saveCAS

; Untersttzung FLOMON
jumpNONE	.equ	0	; Menpunkte nicht einbinden
jumpFLOMON	.equ	1	; Menpunkt FLOMON Start einbinden
jumpFLOPPY	.equ	2	; Menpunkt FLOPPY Start einbinden
optJUMP		.equ	jumpFLOMON

; Autoflip
autoNONE	.equ	0	; Autoflip komplett abschalten
autoEXEC	.equ	1	; Autoflip nach Execute
autoDRAW	.equ	2	; Autoflip nach Zeichenroutionen
autoBOTH	.equ	3	; Autoflip nach Exec und Draw
optFLIP		.equ	autoBOTH

; Optionale Einstellungen (0=aus 1=an)
optIncludeTest	.equ	0	; Testframework einbinden
optIncludeOpts	.equ	1	; Optionen im Klartext einbinden

; Optionale Menpunkte (0=aus 1=an)
optGOSI		.equ	1	; GOSI Start an $2000
optBASIC	.equ	1	; BASIC Start an $4000
optEZASS	.equ	1	; EZASS Start an $6000

;---------------------------------------------------------------------
; Ab hier Codierung Quellcode
;---------------------------------------------------------------------
; ACHTUNG 
;	fixe Adresse 38h beachten
;	fixe Adresse 66h beachten
;	Code nicht wesentlich verlngern
;--------------------------------------------------------------------
basis		.equ optBASE
		.org basis 

start1:		jp start
schreite:	jp tschreite  	;hl Anzahl vzbeh. Schritte
drehe:		jp tdrehe  	;hl vzbehaftete Richtung Grad
hoch:		jp thoch  	;pen up
runter:		jp trunter  	;pen down
schleife:	jp tloop  	;hl = anzahl schleifen
endschleife:	jp tendloop
setze:		jp tmove  	;hl=x de=y bc=phi
mveto:		jp moveto 	;hl=x de=y
drwto:		jp drawto 	;hl=x de=y
texta1:		jp textaus 	;hl->Versorgungsblock
texte1:		jp textein 	;hl->Versorgungsblock c=flag 0,1
ci1:		jp ci  		;hole zeichen nach akku
csts1:		jp csts  	;a=0ffh wenn zeichen da sonst 0

#IF optSAVE=saveCAS
ri1:		jp ri  		;lese kassette nach a
po1:		jp poo	  	;schreibe reg c nach kassette
#ENDIF

#IF optSAVE=saveUSB
ri1:		ld a,0\ ret
po1:		ret\ nop\ nop
#ENDIF

#IF optSAVE=saveNONE
ri1:		ld a,0\ ret
po1:		ret\ nop\ nop
#ENDIF

clra1:		jp clrall 	;loescht alle ebenen
clrpage:	jp clrinvis 	;seite loeschen auch unsichtbar


		.org basis+38h	;Angleich auf 38h wegen INT
		jp intloc 	;Interrupt INT, RST 7


wait1:		jp wait  	;warten bis gdp fertig ist
schr16tel:	jp tschr16tel


keyd 		.equ 68h 	;daten tastatur + strobe
				;bit 7=1 wenn gelesen
keys 		.equ 69h 	;schalter und ruecksetzen bit 7 auf 1

csts:			;liefert 0ffh wenn zeichen ansteht
	in a,(keyd)
	bit 7,a  	;test ob zeichen da
	jr nz,csts0
	ld a,0ffh
	or a
	ret
csts0:	xor a
	ret

ki:
	call ci  	; mit klein->gross Konvertierung
upper:
	cp 'z'+1
	ret nc
	cp 'a'
	ret c
	sub 32		; vorher: sub 'a' & add a,'A'
	ret


; TEXTMULTI
;	Routine zur Ausgabe von Textblcken mit TEXTSETAUS
;	mehrere Textblcke wie bei TEXTAUS hintereinander
;	Abschluss des Blocks mit $FFFF
; Eingangsregister
;	HL = Adresse des Datenblocks

textmulti:
	ld a,(hl)	; Check auf Ende der Tabelle
	cp $FF		; Wenn $FF dann Ende
	jr z,tmend

	call textsetaus	; Ausgabe ein Block
	inc hl		; auf nchsten Block
	jr textmulti	; und weiter
tmend:
	RET


;--------------------------------------------------------------------
; ACHTUNG fixe Adresse 66h - Einsprung bei NMI
;--------------------------------------------------------------------
	.org basis+66h
	jp nmiloc



;---------------------------------------------------------------------
; Version 3.1 Erweiterung Start
; Zustzliche Sprungvektoren zum Betrieb mit dem Assembler-ROM 
; Nachfolgende Routinen verschieben sich um 3*Anzahl der Vektoren

length1:	jp length	;Befehlslnge, hl Zeiger auf Befehl
				;Originaladresse GRUND20: $0D2A
				;Neue Adresse in GRUND31: $0069
				;Verwendung in EZASS    : 
				
getsym1:	jp getsym	;hole Symbol ab (ix) aus Symboltabelle
				;Originaladresse GRUND20: $0AD0
				;Neue Adresse in GRUND31: $006C
				;Verwendung in EZASS    : 
				
putsym1:	jp putsym	;(ix),hl nach Symboltabelle ablegen 
				;Originaladresse GRUND20: $0BEE
				;Neue Adresse in GRUND31: $006F
				;Verwendung in EZASS    :
				
loesym1:	jp loesym	;Symbol (ix) loschen
				;Originaladresse GRUND20: $0B70
				;Neue Adresse in GRUND31: $0072
				;Verwendung in EZASS    : 
				
suchadr1:	jp suchadr	;suche Adresse in Symboltabelle
				;Originaladresse GRUND20: $0BB6
				;Neue Adresse in GRUND31: $0075
				; Verwendung in EZASS   : 
				
progst1:	jp progstart	;starten eines Programms ab Adresse
				;Originaladresse GRUND20: $1B86
				;Neue Adresse in GRUND31: $0078
				;Verwendung in EZASS    : $7E93

stepst1		jp stepstart	;Einzelschrittausfhrung Programm
				;Originaladresse GRUND20: $1A3F
				;Neue Adresse in GRUND31: $007B
				;Verwendung in EZASS    : $7EA4
				
; Version 3.1 Erweiterung Ende
;---------------------------------------------------------------------


			
; Wartet bis Zeichen da und holt es in den Akku
ci:			
#IF optFLIP != autoNONE
	; Flip mode bearbeitung+ci
	call autoflip 	; Seitenwechsel schalten
#ENDIF
	in a,(keyd)
	bit 7,a
	jr nz,ci
	push af
	in a,(keys) 		;loeschen status
	pop af
	ret  			;bit 7=0 per definition

#IF optFLIP != autoNONE
autoflip:
	ld a,(flip1) 		;4fach autoswap
	or a
	jr z,autoflip2		;a<>0 -> zweifach autoflip
	call sync
	jr c,autoflip2		;sync -> zweifach autoflip
	call grapturt
	ld a,(flip1cnt)
	cp 1
	jr nz,autoflip1		;1 -> herabzhlen
	ld a,(flip1)
	ld (flip1cnt),a
	ld a,(viewpage)
	inc a
	and 00000011b
	ld (viewpage),a
	call aktpage 		;Ausgabseite setzen
	jr autoflip2		;noch zweifach
autoflip1:
	dec a
	ld (flip1cnt),a
autoflip2:
	ld a,(flip) 		;2fach swap
	or a
	jr z,autoflipx		;a<>0 -> fertig
	call sync
	jr c,autoflipx		;sync -> fertig
	call grapturt
	ld a,(flipcnt)
	cp 1
	jr nz,autoflip3		;1 -> herabzhlen
	ld a,(flip)
	ld (flipcnt),a
	ld a,(viewpage)
	xor 00000001b
	and 00000011b
	ld (viewpage),a
	call aktpage
	jr autoflipx		;fertig
autoflip3:
	dec a
	ld (flipcnt),a
autoflipx:
	ret
#ENDIF


#IF optSAVE=saveCAS
;---------------------------------------------------------------------
; KASSETTEN ROUTINEN CAS

cmdcas   	.equ 	0cah
datcas  	.equ 	0cbh 

casinit:			;setup
	ld a,53h 		;*1 baudrate
	out (cmdcas),a
	ld a,50h
	out (cmdcas),a 		;setup
	ret
ri:
	in a,(cmdcas)
	and 1
	jr z,ri  		;warten bis zeichend da
	in a,(datcas) 		;lesen der daten
	ret
poo:
	in a,(cmdcas)
	and 10b
	jr z,poo 		;warten bis ausgabe fertig
	ld a,c
	out (datcas),a
	ret
;---------------------------------------------------------------------
#ENDIF




;---------------------------------------------------------------------
; GDP Routinen

page 		.equ 	60h
gdp 		.equ 	70h
gdp_cmd		.equ	70h
gdp_ctrl1	.equ	71h
gdp_ctrl2	.equ	72h
gdp_csize	.equ	73h
gdp_dx		.equ	75h
gdp_dy		.equ	77h
gdp_msbx	.equ	78h
gdp_lsbx	.equ	79h
gdp_msby	.equ	7ah
gdp_lsby	.equ	7bh
gdp_stat	.equ	70h


wait:	push af		;Warten bis GDP fertig
waitlp:	in a,(gdp)	;Status lesen
	and 4
	jr z,waitlp 	;warten bis nicht mehr busy
	pop af
	ret


setpen:	xor a		;GDP Schreibfunktion
	jr era1
erapen:	ld a,1		;GDP Lschfunktion
era1:	call cmd
	ld a,2		;Sichtbar schreiben


cmd:	call wait 	;Ausgabe des akkuinhalts an GDP
	out (gdp),a
	ret

clrall:			;alle bildseiten loeschen
			;nach clrall page 0 aktiv
	ld a,01010000b
	call clear 	;page 1
	ld a,10100000b
	call clear 	;page 2
	ld a,11110000b
	call clear	;page 3
	ld a,00000000b

clear:			;bildschirm loeschen eine page
			;akku = pageadresse

	call wait 	;warten bis cmd fertig von frueher
	and 11110000b
	out (page),a
	ld a,00000111b 	;blank of sonst fehler beim clear
	out (gdp_ctrl1),a
	ld a,00000100b 	;clear screen
	call cmd
	call wait
	ld a,00000011b 	;old state
	out (gdp_ctrl1),a
	ret

aktpage:		;page aus viewpage,wrtpage bilden
	ld a,(wrtpage)
	rlca
	rlca
	and 00001100b
	ld b,a
	ld a,(viewpage)
	and 00000011b
	or b
	rlca
	rlca
	rlca
	rlca		;danach in setpage laufen
setpage:		;page auswaehlen in akku
	call wait
	push bc
	and 0f0h 	;rest must be stable
	ld b,a
	in a,(page)
	and 0fh
	or b
	out (page),a
	pop bc
	ret

moveto:			;procedure moveto(x,y)
setxy:			;hl = x   de = y
	call wait
	ld a,h
	out (gdp_msbx),a
	ld a,l
	out (gdp_lsbx),a
	ld a,d
	out (gdp_msby),a
	ld a,e
	out (gdp_lsby),a
	ret

drawto:			;procedure drawto(x,y)
			; hl= newx  de=newy

			; procedure drawto(x,y)
			; begin
			;  dx := x-xalt
			;  dy := y-yalt
			;  if abs(dx)>255 or abs(dy)>255
			;   drawto(xalt+dx/2,yalt+dy/2)
			;   drawto(x,y)
			;  else
			;   draw1(dx,dy)
			;  endif

	ld (newx),hl	;temp
	ld (newy),de	;temp

	call wait  	;warten bis terminiert
	in a,(gdp_msbx)	;msb
	bit 3,a  	;msb bit sign
	jr z,dw1
	or 11110000b
dw1:
	ld d,a
	in a,(gdp_lsbx)	;lsb x
	ld e,a
	ld (oldx),de 	;save old x
	ld hl,(newx) 	;new - old = dx
	xor a
	sbc hl,de 	;
	ld (dx),hl
	in a,(gdp_msby) ;msb y
	bit 3,a  	;msb bit sign
	jr z,dw2
	or 11110000b
dw2:
	ld d,a
	in a,(gdp_lsby)
	ld e,a  	;lsb y
	ld (oldy),de 	;save old y
	ld hl,(newy)	
	xor a
	sbc hl,de 	; dy
	ld (dy),hl
	ld de,(dx)
	bit 7,h
	jr z,mmm1
	call neghl 	;new hl
mmm1:
	bit 7,d
	jr z,mmm2
	ex de,hl
	call neghl
	ex de,hl
mmm2:
			;hl = abs(dy) de = abs(dx)
	LD A,h		;wenn beide 0, dann berspringen
	OR A
	JR NZ,mm3
	LD A,d
	OR A
	JR Z,mm4
mm3:
	ld hl,(newx) 	;save on stack
	ld de,(newy)
	push hl
	push de 	;recursiv call
	ld hl,(dx) 	;div 2 signed
	sra h
	rr l
	ld de,(oldx)
	add hl,de 	;hl := oldx + dx/2
	push hl
	ld hl,(dy)
	sra h
	rr l
	ld de,(oldy)
	add hl,de
	ex de,hl 	;de := oldy + dy/2
	pop hl  	;hl = x  de = y
	call drawto
	pop de
	pop hl  	;parameter destination
	call drawto
	ret
mm4:
	ld hl,(dx)
	ld de,(dy)
	call draw1
	ret


			; setmode or reset mode must be set before
draw1:			;hl = deltanewx   de = deltanewy  
			;vorzeichenbehaftet
	ld b,00010001b 	;signcode + cmd
	bit 7,h
	jr z,dr1
	call neghl
	set 1,b  	;sign x
dr1:
	bit 7,d
	jr z,dr2
	ex de,hl
	call neghl
	ex de,hl
	set 2,b  	;sign y
dr2:			;nun ausfuehren moeglich
	call wait
	ld a,l  	;delta x
	out (gdp_dx),a
	ld a,e
	out (gdp_dy),a 	;delta y
	ld a,b  	;cmd
	call cmd
	ret



sync:			;warten auf vertical blank
	in a,(gdp_stat)
	and 2
	jr z,sy1
	ld a,(synstate) 	;=0 dann ____------
	or a
	scf
	ret nz  		;<>0 dann carry
	inc a  			;=1
	ld (synstate),a 	;set to one
	xor a  			;kein carry
	ret
sy1:
	xor a
	ld (synstate),a 	;set to zero
	scf
	ret


clrinvis:		;clear invisible aktpage
			;muss mit Ausgabe von Blcken gemacht werden

	call erapen 	;Lschmodus fr Ausgaben
	ld a,0		;size auf max. 16 fach
	call setsize
	ld a,0		
	call setline 	;characters std
	ld de,0 	;y := 0
	LD b,4  	;4 Zeilen = 4*64 = 256 pixel
clrnxrow:
	ld hl,0 	;x := 0
	call setxy
	LD c,8 		;8 Spalten = 8*64 = 512 pixel
clrnxcol:
	ld a,0bh 	;4*4 square = 64x64 pixel
	call cmd 	;cmd out
	dec c
	jr nz,clrnxcol
	ld hl,16*4	;neue Spaltenposition
	add hl,de
	ex de,hl 	;next y
	djnz clrnxrow
	ld a,00010001b	;size wieder auf $11

setsize:		;Zeichengre setzen
	call wait
	out (gdp_csize),a
	ret

setline:
	call wait
	out (gdp_ctrl2),a
	ret


adj360:			;hl to range 0..359
			;Unterprogramm fr Circle
	ld de,360	;zum Addieren oder Subtrahieren
	ld a,h
	or a
	jp m,adj360neg	

adj360pos:		;solange 360 abziehen bis neg
	xor a
	sbc hl,de
	ld a,h
	or a
	jp m,adj360neg	;jetzt negativ, einmal addieren
	jr adj360pos
	
adj360neg:
	add hl,de  	;solange 360 addieren bis positiv
	ld a,h
	or a
	jp m,adj360neg
	ret		;fertig


mult16:			;16  hl*de -> hlde in b vz von hl
	ld c,0
	ld a,d
	or a
	jp p,mult16pos

	ld c,1  	;vz flag
	cpl
	ld d,a
	ld a,e
	cpl
	ld e,a
	inc de  	;complement

mult16pos:
	ld a,b
	xor c
	ld (vzsto),a 	;save result sign
			; hl=0..256 wert sinus  de=n multiplikator
			; h merken
	bit 0,h
	jr nz,mal256 	;bleibt so * 256 / 256 
			; zunaechst annehmen das 8 x 16 bit
	ld a,l 		;kleiner multiplikand
	ld c,8 		;counter
	ld hl,0 	;ergebnis

qq1:
	add hl,hl 	;mal 2
	rla
	jr nc,qq2
	add hl,de 	;multipl dazu
	adc a,0
qq2:
	dec c
	jr nz,qq1 	;weiter so 
			; ergebnis a  h  l
	ld l,h
	ld h,a 		;div256 ausgefuehrt

reent1:
	ld a,(vzsto)
	or a  		;=0 pos sign
	ret z
neghl:			;entry -- wird global mitverwendet
	ld a,h  	;im gesamten Programm
	cpl
	ld h,a
	ld a,l
	cpl
	ld l,a
	inc hl
	ret  		;ready

mal256:
	ex de,hl 	;hl wird de
	jr reent1 	;und ausfuehren


sintab:
	.byte 0,4,9,13,18,22,27,31,36
	.byte 40,44,49,53,58,62,66,71,75
	.byte 79,83,88,92,96,100,104,108,112
	.byte 116,120,124,128,132,136,139,143,147
	.byte 150,154,158,161,165,168,171,175,178
	.byte 181,184,187,190,193,196,199,202,204
	.byte 207,210,212,215,217,219,222,224,226
	.byte 228,230,232,234,236,237,239,241,242
	.byte 243,245,246,247,248,249,250,251,252
	.byte 253,254,254,255,255,255,0,0,0,0

cos:			; Cosinus
			; Bereiche 0 bis 359 sind nur erlaubt 
	ex de,hl
	ld hl,90
	xor a
	sbc hl,de 	;phi-90
			; wenn kleiner null addieren 360
	bit 7,h
	jr z,sin
	ld de,360
	add hl,de

sin:			; Sinus
	ld (sitemp),hl
	ld b,0		;sign
	ld de,90
	xor a
	sbc hl,de

	jp m,sin0
	ld de,90
	xor a
	sbc hl,de 
	jp m,sin1

	ld b,1 		;sign is negative
	ld de,90 
	xor a
	sbc hl,de
	jp m,sinq4

	ld hl,360
	ld de,(sitemp)
	xor a
	sbc hl,de
	jr sinq1

sinq4:
	ld hl,(sitemp)
	ld de,180
	xor a
	sbc hl,de
	jr sinq1

sin1:
	ld de,(sitemp)
	ld hl,180 	;
	xor a
	sbc hl,de
	jr sinq1

sin0:
	ld hl,(sitemp) 	;0..89
sinq1:
	ld a,h
	or l  		;important
	ret z  		;sin(0)=0
	ex de,hl
	ld hl,sintab
	add hl,de
	ld l,(hl)
	ld h,0  	;0..255
	ld a,l
	or a
	ret nz
	ld h,1  	;256 if sin(90)
	ret


getkoor:		;define xkoor,ykoor
	call wait
	in a,(gdp_msbx)
	ld (xkoor+1),a	;msb x
	in a,(gdp_lsbx)
	ld (xkoor+0),a 	;lsb x
	in a,(gdp_msby)
	ld (ykoor+1),a 	;msb y
	in a,(gdp_lsby)
	ld (ykoor+0),a 	;lsb y
	ret

setkoor:		;setzen nach gdp
	call wait
	ld a,(xkoor+1)
	out (gdp_msbx),a
	ld a,(xkoor+0)
	out (gdp_lsbx),a
	ld a,(ykoor+1)
	out (gdp_msby),a
	ld a,(ykoor+0)
	out (gdp_lsby),a
	ret

getparam:		; parameter laden hl-> anfang
	call wait 	
	ld a,(hl) 		; lsb x
	out (gdp_lsbx),a
	inc hl
	ld a,(hl	) 	; msb x
	out (gdp_msbx),a
	inc hl
	ld a,(hl) 		; lsb y
	out (gdp_lsby),a
	inc hl
	ld a,(hl) 		; msb y
	out (gdp_msby),a
	inc hl
	ld a,(hl)
	out (gdp_csize),a 	;size
	inc hl
	ld a,(hl) 		;vektor etc.
	out (gdp_ctrl2),a
	inc hl  		;zeigt auf textstart
	ret
	
; GDP ENDE 
;---------------------------------------------------------------------



;---------------------------------------------------------------------
; STRUKTUR MODULE

tloop:			;hl = anzahl der schleifen
	ld (desto),de 	;dort aktuellen wert merken
	ex (sp),hl 	;hl = ret adr
	push hl
	ld de,modber+3 	;wenn rueckadresse modber
	xor a
	sbc hl,de
	ld a,h
	or l
	pop hl  	;wenn modber dann sonderbehandlung
	jr z,tloop1 	;sonderbehandlung
	push hl  	;auch auf stack
	ld de,(desto)
	jp (hl)  	;und dahin zurueck springen

tloop1:			;von step aus behandelt
			;hl =ret adresse modber
	ld de,(pcsto) 	;naechster Befehl
	push de  	;als echte rueckkehradresse
	ld de,(desto) 	;wieder zurueck de alt
	jp (hl)  	;aber zurueck in den modber


tendloop:		;ende einer schleife
	ld (desto),de
	ld (bcsto),bc 	;auch in step verwendet
	pop hl  	;hl=ret adresse uprg
	pop de  	;de=ret adresse tloop
	pop bc  	;bc=schleifenzaehler
	dec bc
	ld a,c
	or b  		;=0 dann ende
	jr nz,tend1 	;sonst rueckkehr
	ld de,(desto)
	ld bc,(bcsto)
	jp (hl) 	;ret ausfuehren std
tend1:			;de = retadr  realer wert
			; ist retadr - 3
	dec de
	dec de
	dec de  	;zeigt auf anfang tloop
	push de  	;auf stack pc bei step
	push de  	;
	push hl
	ld de,modber+3 	;wenn dort dann stepaufruf
	xor a  		;wenn tloop von da aufgerufen
	sbc hl,de
	ld a,h
	or l
	pop hl
	pop de  	;wenn = modber
	jr z,tspez1
	xor a  		;akkus gleich fuer step
	ld l,c
	ld h,b  	;parameter wie bei start
	ld de,(desto)
	ld bc,(bcsto) 	;alte werte
	ret  		;nach tloop zurueck

tspez1:			;bei einzelschritt
	pop de  	;sprungziel
	ld (pcsto),de 	;sprung implizieren 
	push hl  	;ret adresse modber
	ld l,c
	ld h,b  	;parameter fuer tloop
	xor a  		;akku gleich 
	ret  		;und nach modber zurueck

; STRUKTUR ENDE
;---------------------------------------------------------------------



;---------------------------------------------------------------------
; ZEICHEN Routinen

firsttime:
	ld hl,256
	ld de,256
	ld bc,90 	;start marke

tmove:			;positionieren marke
			;hl = x  de = y  bc = phi
	call m16 	;first hier loeschen wenn nicht 
	ld (turx),hl 	;erstes mal da extern aufrufbar
	ex de,hl
	call m16
	ld (tury),hl
	ld l,c
	ld h,b
	call adj360 	;0..359
	ld (turphi),hl
	call setturt 	;wichtig fuer start
	ld a,1
	ld (flip),a
	ld (flipcnt),a 	;flipcount 1
	xor a
	ld (first),a 	;nicht mehr first
	ret



tschreite:
	call m16 	;wert aufbereiten

tschr16tel:		;1/16 schrittweite
	push af
	push bc
	push de
	push hl
	push hl
	ld a,(first)
	cp 1
	jr nz,tschr1st
	call firsttime
tschr1st:
	ld hl,(turphi)
	call cos
	pop de  	;ursp hl  ist schreitewert
	push de
	call mult16
	ld de,(turx)
	add hl,de
	ld (turx),hl
	ld hl,(turphi)
	call sin
	pop de
	call mult16
	ld de,(tury)
	add hl,de
	ld (tury),hl
	ld hl,(turx)
	ld de,(tury)
	call div16a
	ld a,(turdo)

	cp 1
	jr nz,tschr16mve
	call drawto
	jr poparet	; wie ende von tdrehe
tschr16mve:
	call moveto
	jr poparet 	; wie ende von tdrehe



tdrehe:			;hl = drehewert
	push af
	push bc
	push de
	push hl
	ld a,(first)
	cp 1
	jr nz,tdrehe1st
	push hl
	call firsttime
	pop hl
tdrehe1st:
	ld de,(turphi) 	;alter wert
	add hl,de
	call adj360 	;0..359
	ld (turphi),hl
poparet:
#IF optFLIP = autoDRAW
	call autoflip 	;seitenwechsel ggf.
#ENDIF
	pop hl
	pop de
	pop bc
	pop af
	ret


thoch:
	push af
	xor a
	ld (turdo),a
	pop af
	ret

trunter:
	push af
	ld a,1
	ld (turdo),a 	;akku destroyed
	pop af
	ret

m16:			;parameter nur 1/16 aufloesung
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ret


grapturt:
	ld a,(first)
	or a
	ret nz  	;=0 dann ok
			;ausgabe marke durchfuehren,setturt

setturt:
	push hl
	push de
	push bc
	ld hl,(tur1x)
	ld de,(tur1y)
	call div16a
	call moveto 	;marke auf seite 1 zeichnen
	ld a,1
	ld (wrtpage),a
	call aktpage 	;ok page set
	call erapen
	call turtle
	ld hl,(turphi)
	ld (tur1phi),hl
	ld hl,(turx)
	ld (tur1x),hl
	ld de,(tury)
	ld (tur1y),de
	call div16a
	call moveto 	;marke auf seite 1 zeichnen
	call setpen
	call turtle
	xor a
	ld (wrtpage),a
	call aktpage
	pop bc
	pop de
	pop hl
	ret


turtle:			;turtle at akt pos  tur1phi beruecks
			;8 verschiedene turtles

	ld hl,(tur1phi) ;/45 ergibt 0..7
	xor a
	ld b,16
turlp:
	sla l
	rl h
	rla
	cp 45
	jr c,L36
	set 0,l
	sub 45
L36:
	djnz turlp 	;rest in akku  hl ist ergebnis
	ld h,0 		;safety
	ld a,l
	and 7
	ld l,a
	add hl,hl
	add hl,hl 	;*4
	add hl,hl 	;*8
	ld de,turtab
	add hl,de 	;+ basis

	ld e,8		;Schleife 8
L37:
	ld a,(hl)
	or a
	jr z,L38	;a <> 0
	call cmd
L38:
	inc hl
	dec e
	jr nz,L37
	ret

turtab:
	.byte 11111010b,11111101b,11111111b,11111010b,0,0,0,0
	.byte 11010011b,11010000b,11010000b,11010100b,11010100b,11010011b,0,0
	.byte 11111110b,11111001b,11111101b,11111110b,0,0,0,0
	.byte 11010111b,11010010b,11010010b,11010000b,11010000b,11010111b,0,0
	.byte 11111100b,11111011b,11111001b,11111100b,0,0,0,0
	.byte 11010101b,11010110b,11010110b,11010010b,11010010b,11010101b,0,0
	.byte 11111000b,11111111b,11111011b,11111000b,0,0,0,0
	.byte 11010001b,11010100b,11010100b,11010110b,11010110b,11010001b,0,0



div16a:			;/16 de,hl teilen und de /2 falls teilflag
	push bc

	ld b,4		;Schleife 4 mal
div16a4:		;HL / 16
	sra h
	rr l
	djnz div16a4	;Ende Schleife

	ld b,4		;Schleife 4 mal
div16a45:		;DE / 16
	sra d
	rr e
	djnz div16a45	;Ende Schleife
	
	ld a,(teilflag)	;Zusatzteilung fr DE
	cp 1
	jr nz,div16aex
	sra d		;DE / 2
	rr e
div16aex:
	pop bc
	ret


setupturt:
	push hl
	call clrall 		;leerer bildschirm
	ld a,0
	ld (wrtpage),a
	ld (viewpage),a
	call aktpage 		;seite 0,0 anwaehlen
	ld a,1  		;512 x 256
	ld (teilflag),a 	;
	ld (turdo),a 		;pen down
	ld hl,0 		;0,0 mitte position
	ld (tur1x),hl
	ld (tur1y),hl
	ld (tur1phi),hl
	ld (turx),hl
	ld (tury),hl
	ld (turphi),hl 		;init werte setzen
	ld a,1  		;first flag
	ld (first),a 		;damit init in grap moeglich
	pop hl
	ret



; ENDE TURTLE
;---------------------------------------------------------------------



;---------------------------------------------------------------------
; TEXT ROUTINEN EINFACH

; Size
;	b0..b3	XSize: 1..15, 0=16 fach vergrert
;	b4..b7	YSize: 1..15, 0=16 fach vergrert
; Vektor
;	b0,b1	Line: 0=continuous, 1=dotted, 2=dashed, 3=dotted dashed
;	b2,b3	Text: 0=horizontal, 4=hor.kursiv, 8=vertikal, 12=vert.kursiv

textsetaus:
	call setpen

textaus:		;hl zeigt auf den Start eines Versorgungsblocks
			; x x y y size vektor  nnnnn 0
	push hl
	pop ix  	;ix verwenden intern
	call getparam 	;hl nach block

textauslp:		;solange (HL) <> 0
	ld a,(hl)
	or a
	jr z,textausx
	call charclear	; Zeichenposition lschen
	ld a,(hl)	; Zeichen holen
	and 7fh		; ASCII
	call cmd 	; Ausgabe
	inc hl		
	jr textauslp
textausx:
	ret  		;ende textausgabe


charclear:
	call getkoor 		;definieren xkoor , ykoor
	call wait
	call erapen
	ld a,1010b 		;Block zeichen 5x8 * csize
	call cmd
	call setkoor
	call wait
	call setpen
	ret

;------------------------------------------------------------
; TEXT ROUTINEN GEPUFFERT
;
; Unterprogramme fuer Ausgabe von Werten in BUFFER 
; IX zeigt auf das Ziel, den naechsten freien Speicherplatz
;

prthl:			;ausgabe HL
	push af
	ld a,h
	call prtac
	ld a,l
	call prtac
	pop af
	ret

prtac:			;ausgabe A
	push af
	push af
	rrca
	rrca
	rrca
	rrca
	and 0fh
	call nibble
	pop af
	and 0fh
	call nibble
	pop af
	ret
	
nibble:
	cp 10
	jr c,nib0bis9
	sub 10
	add a,'A'
	jr nibout
nib0bis9:
	add a,'0'
nibout:
	ld (ix+0),a 	;ablegen
	ld (ix+1),0 	;0=endezeichen
	inc ix  	;naechster freier Platz
	ret


prtbin:			;Ausgabe akku binaer
	push bc
	ld b,8		;Schleife 8 mal
prtbinlp:
	rlca
	jr nc,prtbin0
	ld (ix+0),'1'
	jr prtbinnx
prtbin0:
	ld (ix+0),'0'
prtbinnx:
	inc ix
	djnz prtbinlp
	ld (ix+0),0	;Endezeichen
	pop bc
	ret




print:			;ausgabe eines textes start bei hl
			;nach (ix) bis ende = 0
	push af
	push hl
printlp:
	ld a,(hl)
	or a
	jr z,printexit
	ld a,(hl)
	ld (ix+0),a
	inc ix
	inc hl
	jr printlp
printexit:
	ld (ix+0),0 	;Endezeichen nach ziel
	pop hl
	pop af
	ret

printin:		;Ausgabe eine Inline-Textes der hinter dem Call beginnt
			;Rcksprungadresse auf dem Stack wird manipuliert
			;Spart 3 Byte Bei Texten, die nur einmal genutzt werden
			;Lnge der Routine 20 Byte


	ex (sp),hl	;Adresse des Strings
	push af
printinlp:
	ld a,(hl)	;Zeichen holen
	inc hl		;Pointer erhhen
	or a		;bei 0 fertig
	jr z,printinex
	ld (ix+0),a	;Zeichen nach ausbuf
	inc ix		;Pointer erhhen
	jr printinlp	;nchstes Zeichen
printinex:
	ld (ix+0),0	;Endezeichen nach Ziel
	pop af
	ex (sp),hl	;Adresse wieder auf Stack
	ret		;und weiter im Programm


prtbit:			;Ausgabe bit 0 von Accu
	bit 0,a
	jr z,prtbit0
	ld (ix+0),'1'
	jr zeich1
prtbit0:
	ld (ix+0),'0'
	jr zeich1

blank:			;Ausgabe Leerzeichen
	ld (ix+0),' '
	jr zeich1

newline:		;Ausgabe <cr> Neue Zeile
	ld (ix+0),0dh
	jr zeich1

zeich:			;Ausgabe Zeichen in Accu
	ld (ix+0),a
zeich1:
	ld (ix+1),0
	inc ix
	ret


prtbytes:		;n bytes ab hl ausgeben  - "XX XX XX XX"
	push af
	jr prtbytes0
prtbytes1:
	call blank
prtbytes0:
	ld a,(hl)
	call prtac
	inc hl
	djnz prtbytes1
	pop af
	ret


setausbuf:		;parameter belegen
			;hl=x de=y a=size
			;ix nachher ausbuf+6
	ld (ausbuf),hl
	ld (ausbuf+2),de
	ld (ausbuf+4),a 	;size
	xor a
	ld (ausbuf+5),a		;flags
	ld ix,ausbuf+6
	ret


textprint:
	; Text ab ix in Ausbuf bertragen
	push af
	ld iy,ausbuf+6
textprlp:
	ld a,(ix+0)
	ld (iy+0),a
	inc ix
	inc iy
	or a
	jr nz,textprlp
	pop af
	; weiter bei printbuf	


; Ausdruck des Buffers (AUSBUF)
; Input
;	HL	X-Koordinate
;	DE	Y-Koordinate
;	ACCU	Size
; Registernutzung
;	ACCU	zerstrt
;	HL	zerstrt
;	DE	zerstrt
;	IX	interner Pointer, gesichert

printbuf:
	; Positionsdaten und Gre im Buffer ablegen
	push ix			; Pointer retten
	call setausbuf		; Parameter in Buffer bertragen
	ld hl,ausbuf		; Vorbereiten Ausgabe
	call getparam 		; Parameter nach GDP

printbuflp:			; Ausgabeschleife
	ld a,(ix)		; Zeichen holen
	or a
	jr z,printbufx		; Endekennung

	call charclear		; Zeichenposition lschen
	ld a,(ix)		; Zeichen erneut holen
	cp 0dh			; <cr> ?
	jr z,printbufcr
	cp 0ah			; <lf> ?
	jr z,printbufcr
	and 7fh			; ASCII Maskierung
	call cmd 		; Ausgabe ber GDP
	call wait		
	in a,(gdp_msbx)		; xpos aus gdp lesen 
	and 11111110b		; > 512 ?
	jr nz,printbufcr	; wie <cr> behandeln

printbufc:
	inc ix			; nchstes Zeichen
	jr printbuflp		; zum Anfang der Schleife
	
printbufx:			; Endekennung erkannt
	pop ix			; Pointer wiederherstellen
	ret			; Fertig

printbufcr:			; crlf behandeln
	call wait
	in a,(gdp_msby)		; ypos aus gdp lesen
	ld h,a
	in a,(gdp_lsby)
	ld l,a
	ld a,(ausbuf+4)		; Zeichenhhe *10 berechnen
	and 0fh 		; YSIZE maskieren
	rla			; *2
	ld e,a			; sichern
	rla			; *4
	rla			; *8
	add a,e			; Accu = 10*SIZEY
	ld e,a			; bertragen wg. 16 bit Subtraktion
	xor a			; wichtig wegen SBC
	ld d,a			; DE = 10*SIZEY
	sbc hl,de		; Hhe abziehen
	ld a,h
	out (gdp_msby),a	; YPOS in gdp setzen
	ld a,l
	out (gdp_lsby),a
	ld hl,(ausbuf)		; XPOS wieder auf originalen Wert
	ld a,h
	out (gdp_msbx),a
	ld a,l
	out (gdp_lsbx),a
	jr printbufc		; Weiter in nchster Zeile



;------------------------------------------------------------------
; TEXTEIN

textxy:			;texteingabe aufrufen mit stdwerten
			;default ist linbuf

	ld (linbuf),hl  	;hl = x
	ld (linbuf+2),de 	;de = y
	ld (linbuf+4),a  	;a  = size
	ld a,0		   	;b  = anzahl max 
	ld (linbuf+5),a 	;type = 0
	ld a,b   		;max = b zeichen
	ld (linbuf+6),a 	;+7 wird von textein auf 0 gesetzt
	ld c,1  		;mit umrandung
	ld hl,linbuf 		;pointer auf buffer


textein:	;hl zeigt auf Versorgungsblock
		; x x y y size vekt max akt  free
		; 0 1 2 3 4    5    6   7
		;c=1 dann mit umrandung
		;autoselekt erase pen und clear fenster
		;in akku ist terminator
		;x=0 oder y=0 ohne Umrandung durchf.

	push hl		;Versorgungsblockadr nach ix
	pop ix  	;zusaetzlich verwenden
	xor a
	ld (ix+7),a 	;aktuell auf 0 setzen
	ld a,(ix+4)
	call setsize
	ld a,(ix+5)
	and 0100b 	;line def
	call setline 	;nur schraeg erlaubt
	push bc  	;retten umrandflag

	ld a,c		;Umrandung?
	cp 1
	jr nz,textein1
	call setpen
	call umrande

textein1:
	push ix		;Versorgungsblockadr nach hl
	pop hl
	call getparam
	call getkoor 	;xkoor und ykoor definieren

	call erapen 	;loeschen
	ld b,(ix+6) 	;anzahl
textein2:
	ld a,1010b 	;block
	call cmd
	djnz textein2

	push ix		;Versorgungsblockadr nach hl
	pop hl
	ld de,8		;Beginn des Textbuffers
	add hl,de
	ld (txtpoi),hl
	ld (hl),0 	;endezeichen
	xor a
	ld (synccnt),a 	;20 ms counter

; Schleife bis maxchar oder <cr>
texteloop:
	call csts	;ff wenn zeichen da
	cp 0ffh 
	jr nz,textblink

	call ci		;jetzt einlesen
	and 7fh
	ld (lastsym),a 	;terminator

	cp 8 		;<bs>
	jr z,textedel
	cp 7fh 		;<del>
	jr nz,textein3

textedel:
	call delpos 	;cursor ggf. loeschen
	ld a,(ix+7)
	or a  		;nicht wenn null
	jr z,textblink

	dec a
	ld (ix+7),a  	;neuer maxzaehler
	ld hl,(txtpoi)
	dec hl
	ld (hl),0  	;endezeichen 
	ld (txtpoi),hl
	ld a,(ix+4)	
	rrca
	rrca
	rrca
	rrca
	and 0fh  	;size in x-richtung
	ld c,a
	xor a
	ld b,6		;6*size addieren
textedell:
	add a,c
	djnz textedell
	ld hl,(xkoor)
	ld c,a
	ld b,0
	xor a
	sbc hl,bc  	;neue koordinaten
	ld (xkoor),hl
	call delpos  	;loeschen zeichen dort
	jr textblink

textein3:
	cp 32		;anderer ctrl code?
	jr nc,textein4
	call delpos
	jr texteexit

textein4:
	push af		;Zeichen ausgeben
	ld hl,(txtpoi)
	ld (hl),a
	inc hl
	ld (hl),0 	;endezeichen
	ld (txtpoi),hl
	call delpos
	call setkoor
	call setpen 	;zurueck und setzen
	pop af
	call cmd 	;zeichen ausgeben
	call getkoor 	;neue position
	ld a,(ix+7) 	;+1
	inc a
	ld (ix+7),a 	;neuer wert
	cp (ix+6) 	;=max dann ende
	jr z,texteexit

;Cursor blinken lassen
textblink:		;alle 13 syncs umschalten
	call sync
	jr c,texteloopx
	ld a,(synccnt)
	inc a
	ld (synccnt),a
	cp 13 		;bei 13 einschalten
	jr nz,textblink1
	call setkoor 	;aktuelle stelle
	call setpen
	ld a,1010b
	call cmd
	jr texteloopx
textblink1:
	cp 26 		;bei 26 ausschalten
	jr nz,texteloopx
	call delpos
	xor a
	ld (synccnt),a

texteloopx:
	JP texteloop	;Weiter als -128 Bytes entfernt


;EXIT Point
texteexit:
	pop bc
	ld a,c		;1 = umranden
	cp 1
	jr nz,texteex1
	call erapen
	call umrande
texteex1:
	ld a,(lastsym)	;mit letztem Zeichen in Accu verlassen
	ret


delpos:
	call setkoor 	;aktuelle pos
	call erapen
	ld a,1010b
	call cmd
	ret




;Eingabefeld umranden, nur bei TEXTEIN verwendet
;vorher setpen zum zeichnen, erapen zum lschen

umrande:		
	push ix		;Eingabepointer nach HL bertragen
	pop hl
	call getparam	;Koordinaten -> GDP

	ld a,3		;unsichtbar schreiben
	call cmd
	ld a,11010111b 	;Kurzvektor: 1 dx dx dy dy r r r
	call cmd 	;dx=2 dy=2 r=links unten
	ld a,2		;sichtbar schreiben
	call cmd
	
;Breite des Feldes berechnen
	ld a,(ix+4) 	;size holen, obere 4 bit = 16x
	and 11110000b	;maskieren
	rrca		;8x
	rrca		;4x
	ld c,a		;merken
	rrca		;2x
	add a,c		;6x
; anzahl * 6x ber addition
	ld c,a		;bc = 6x
	ld b,0
	ld hl,0 	;Summenbildung in HL
	ld a,(ix+6) 	;Anzahl Zeichen holen
umr0lp:
	add hl,bc	;Breite addieren
	dec a
	jr nz,umr0lp	;hl = 6x
	inc hl		;hl = 6x+1
	inc hl  	;hl = 6x+2 = delta x
	push hl

;hhe des feldes berechnen
	ld a,(ix+4) 	;size
	and 00001111b 	;size y
	rla		;2y
	rla		;4y
	rla		;8y
	inc a		;a = 8y+1
	inc a		;a = 8y+2
	inc a  		;a = 8y+3 = delta y

;Linien zeichnen
;in x-richtung mit schleife wegen max lnge 128

;Linie nach oben
	out (gdp_dy),a 	;delta y
	pop hl  	;h = ueberlauf
	sla h  		;h * 2  
	inc h  		;1..n
	ld a,l
	out (gdp_dx),a 	;delta x
	ld a,00010010b 	;dy > 0
	call cmd

;Linie nach rechts
	ld b,h  	;counter 1..
umr1lp:	ld a,00010000b 	;dx > 0
	call cmd
	ld a,128 	;max
	out (gdp_dx),a
	djnz umr1lp

;Linie nach unten
	ld a,l
	out (gdp_dx),a 	;neu setzen
	ld a,00010100b 	;dy < 0
	call cmd

;Linie nach links
	ld b,h
umr2lp:	ld a,00010110b 	; dx < 0
	call cmd
	ld a,128
	out (gdp_dx),a
	djnz umr2lp

;Fertig
	ret





; ENDE TEXT
;---------------------------------------------------------------------




;---------------------------------------------------------------------
; SYMBOLE 

;Tabelle aller reservierten symbole
fixsym:		
	.text "SCHREIT"\ .byte 'E' | 80h
	.word schreite
	.text "SCHR16TE"\ .byte 'L' | 80h
	.word schr16tel
	.text "DREH"\ .byte 'E' | 80h
	.word drehe
	.text "HEB"\ .byte 'E' | 80h
	.word hoch
	.text "SENK"\ .byte 'E' | 80h
	.word runter
	.text "SCHLEIF"\ .byte 'E' | 80h
	.word schleife
	.text "ENDSCHLEIF"\ .byte 'E' | 80h
	.word endschleife
	.text "SE"\ .byte 'T' | 80h 
	.word setze
	.text "MOVET"\ .byte 'O' | 80h
	.word mveto
	.text "DRAWT"\ .byte 'O' | 80h
	.word drwto
	.text "WRIT"\ .byte 'E' | 80h
	.word texta1
	.text "REA"\ .byte 'D' | 80h
	.word texte1
	.text "C"\ .byte 'I' | 80h
	.word ci1
	.text "CST"\ .byte 'S' | 80h
	.word csts1
	.text "R"\ .byte 'I' | 80h
	.word ri1
	.text "P"\ .byte 'O' | 80h
	.word po1
	.text "CL"\ .byte 'R' | 80h
	.word clra1
	.text "CLP"\ .byte 'G' | 80h
	.word clrpage
	.text "WAI"\ .byte 'T' | 80h
	.word wait1
	.text "RA"\ .byte 'M' | 80h
	.word userram  	; Ram-Start

	.byte 0



; Symboltabelle
; 	Ende des Namens ist durch gesetztes 7. Bit gekennzeichnet
;	Die Lnge des Namens ist dynamisch
;	Im folgenden Word ist der Wert abgelegt


getsym:		;hole symbol ab (ix) aus symboltabelle
		;iy zeigt auf den start der symboltabelle
		;ende ist der Wert 0 auf (iy)
		;wert nach hl
		;carry symbol nicht gefunden
		;ix zeigt anschliessend hinter das symbol

	ld a,(ix+0)
	call testsy
	ret c		;fehler carry kein std symbol

getsymlp:
	ld a,(iy+0)	; 0 = Ende der Tabelle
	or a
	jr z,getsymerr

	ld (zeigsy),iy	; Pointer sichern
	ld (zeigqu),ix

L115:
	ld b,(iy+0)	; Zeichen aus Symboltabelle nach B
	res 7,b 	; Ende bit rcksetzen
	ld a,(ix+0)	; Zeichen aus Buffer nach A
	call upper	; Groschrift
	cp b		; wenn a=b dann weitersuchen
	jr nz,getsymnxt	; sonst nchstes Symbol testen

	inc ix 		;erkannt also auf naechsten
	bit 7,(iy+0) 	;gesetzt, dann gefunden falls terminator auf ix
	JR Z,L117

	ld a,(ix+0) 	; Nchstes Zeichen
	call testsy	; Zeichen gltig?
	JR NC,L117

	ld l,(iy+1) 	; Symbolwert nach HL: LSB
	ld h,(iy+2)	; Symbolwert nach HL: MSB
	xor a		; Carry Clear
	ret		; Ende

L117:
	inc iy 		;+1
	xor a 		;no carry
	JR L115

getsymnxt:
	scf  		; nicht gefunden
	ld ix,(zeigqu) 	; Quelle auf alten Wert zurueck
	ld iy,(zeigsy)

getsymend:
	bit 7,(iy+0)	; Ende des Symbols suchen
	inc iy
	jr z,getsymend	; iy zeigt hinter letztes Zeichen also auf L
	inc iy  	; zeigt auf H
	inc iy  	; zeigt auf nchstes symbol
	jr getsymlp	; Weiter bis Tabelle abgearbeitet

getsymerr:
	scf		; Fehlerflag gesetzt
	ret




; Check auf gltige Zeichen fr Symbole [0-9,A-Z,a-z,_]
testsy: 	  	
	cp '9'+1
	jr nc,testsy1
	cp '0'
	jr nc,testsyok
testsy1:
	cp 'Z'+1
	jr nc,testsy2
	cp 'A'
	jr nc,testsyok
testsy2:
	cp 'z'+1
	jr nc,testsy3
	cp 'a'
	jr nc,testsyok
testsy3:
	cp '_'
	jr nz,testsynok
testsyok:
	scf
	ccf
	ret		; Carry Clear
testsynok:
	scf
	ret		; Carry Set




loesym:		;ix->name in quelltext 
		; carry wenn nicht gefunden
		; sonst loeschen in symtab
		;nur fuer symtab da nur diese in RAM
		;Optimierung OK

	ld iy,symtab 	;nur user symbole loeschbar
	call getsym 	;sehen ob da hl gueltig
	ret c		;symbol nicht da 

	push hl  	;beibehalten alten symbolwert
	ld hl,(symanz)
	dec hl
	ld (symanz),hl 	;eins weniger da nun
	ld hl,(zeigsy)
	ld de,0  	;zahl

	bit 7,(hl)
loesymlp:
	jr nz,loesymok
	inc de
	inc hl
	bit 7,(hl)
	jr loesymlp
loesymok:
	inc hl
	inc de
	inc hl
	inc de
	inc hl  		;zeigt auf naechstes symbol
	inc de  		;zahl mind 3..n

	push hl
	ld hl,(symptr) 		;merken fuer anzahl
	pop bc
	push bc  		;bc = quelle
	xor a
	sbc hl,bc 
	ld b,h
	ld c,l  		;bc = laenge
	inc bc  		;laenge +1 wg. endezeichen
	ld hl,(symptr) 
	xor a
	sbc hl,de 		;neuer pointer
	ld (symptr),hl
	pop hl  		; hl = quelle
	ld de,(zeigsy) 		; de = ziel
	ldir  			; bc = laenge
	pop hl  		;alter symbolwert
	ret



putsym:		;ablegen (ix) nach symbol wert in hl
		;carry wenn symbol schon da ist
		;Optimierung OK

	ld iy,symtab 		;nur mit variabler tabelle moeglich
	push hl  		;neuer wert
	push ix
	call getsym
	pop ix
	pop hl 
	jr c,putsymcnt
	scf  			;fehler symbol schon da
	ret			;ende des programms

putsymcnt:
	ld a,(ix+0)
	call testsy
	ret c			;wenn nicht Buchstabe

	ld iy,(symptr) 		;zielpointer
putsymlp:
	ld a,(ix+0) 		;erstes zeichen ok
	call upper
	ld (iy+0),a
	inc ix
	inc iy 
	ld a,(ix+0)
	call testsy
	jr nc,putsymlp		;bis kein buchstabe mehr

	dec iy
	set 7,(iy+0) 		;bit 7 setzen
	ld (iy+1),l
	ld (iy+2),h 		;wert ablegen
	ld (iy+3),0 		;neues endezeichen
	ld de,3
	add iy,de 		;auf nachfolger
	ld (symptr),iy
	ld hl,(symanz)
	inc hl
	ld (symanz),hl
	xor a
	ret




;Zuweisen eines Wertes an Symbol
; name := n	Hexadezimal (auch negativ) name := -1000
; name := #n	Dezimal (auch negativ)     name := -#1000
; name := %	Symbol lschen
; name := $	Aktuelle Adresse
;nderungen ber loesym und putsym
;Optimierungen OK

assign:				;wenn keines carry, sonst zuordnen
	push ix  		;position anfang merken
	call igbn 		;suchen nach namen := wert, igbn ok hier 1.6

	ld a,(ix+0) 
	cp 'z'+1		;muss mit Buchstabe beginnen [A-Z,a-z]
	jr nc,assign2
	cp 'a'+0
	jr nc,assign1
assign2:
	cp 'Z'+1
	jr nc,assignend
	cp 'A'+0
	jr c,assignend

assign1:
	xor a  			;mit testsy zahlenumdef moeglich
assign3:
	jr c,assign4
	inc ix
	ld a,(ix+0)
	call testsy 		;buchstabe oder ziffer
	jr assign3

assign4:
	call igbn 		;leerzeichen ignorieren
	ld a,(ix+0) 		;muss : sein
	cp ':'
	jr nz,assignend
	inc ix			;nchstes Zeichen
	ld a,(ix+0)
	cp '=' 			;muss = sein
	jr nz,assignend
	inc ix 			;nchstes Zeicen
	call igbn
	cp '%' 			
	jr nz,assignval

	inc ix			;LOESCHEN DES SYMBOLES
	ex (sp),ix
	call loesym
	pop ix 			;neuer pointer wenn ok
	ret c			;bei fehler Ende
	xor a		 	;kein fehler ok. geloescht
	ret

assignval:
	call expr 		;wert berechnen
	jr c,assignend		; hl = wert symbol  ix -> aktueller stand

	ex (sp),ix 		; alten ix wert nach ix holen
	push hl
	push ix
	call loesym
	pop ix
	pop hl
	push hl
	call putsym 		; dort ablegen
	pop hl
	pop ix 			;zeigt hinter "nnn := expr"
	xor a
	ret			;ENDE

assignend:
	pop ix  		;fehler wenn hier ausgang
	ld hl,0  		;ungueltig
	scf
	ret





		; ix zeigt auf erstes gueltiges Zeichen
		; hl ist ergebniswert
		; carry wenn ungueltiger Ausdruck
		; oder terminator nicht komma,blank,0 ist
		; in a ist der Symbolcode
		; a=0 dann std expr wert
		; a=1 dann symbol user
		; a=2 dann symbol fix
		; a=3 dann symbol adr unterprg system
		; bit 7=1 dann byte mit .B sonst wort
		; symtyp ist dann identisch

expr:				;wert holen expr nach hl
	call faktor 		;zuerst faktor
	ret c			;fehler

	ld a,(ix+0)		;Zeichen holen

exprloop:			;nur + und - zulssig
	CP '+' 
	JR Z,expr_add
	CP '-'
	JR Z,expr_sub
	jr expr1
expr_add:			;Addition
	inc ix
	push hl
	call faktor		;wert von faktor
	pop de
	RET C			;Abbruch bei Fehler
	add hl,de 		;plus wert
	JR exprlp1
expr_sub:
	inc ix
	push hl			;Subtraktion
	call faktor		;Wert von Faktor
	pop de
	ex de,hl
	RET C			;Abbruch bei Fehler
	xor a
	sbc hl,de 		;minus wert
exprlp1:
	xor a
	ld (symtyp),a 		;nach arithmetik nur noch symbol
	ld a,(ix+0) 		;fuer vergleich
	JR exprloop

expr1:				;keine gltige Operation
	ld a,(symtyp)
	and 11111110b 		;0,1 erlaubt
	OR A			;AUCH BEI USER-SYMBOLEN
	JR NZ,expr_ext
	ld a,h 			;=0 oder ff dann byte
	OR A
	JR Z,expr2		;=0
	CP 0ffh
	JR NZ,expr_ext		;<>FF
expr2:
	ld a,(symtyp)
	or 80h 			;.BYTE  einstellen wenn kleiner
	ld (symtyp),a 		;sonst lassen auf wort


;moeglicherweise .W .B
expr_ext:
	ld a,(ix+0) 		
	CP '.' 			;. ?
	JR NZ,expr_extx
	inc ix
	ld a,(ix+0)
	call upper 		;klein u. grossbuchstaben

	CP 'W'			;.W ?
	JR NZ,expr_extb
	inc ix
	ld a,(symtyp)
	res 7,a			;Word einstellen
	ld (symtyp),a
	JR expr_extx
expr_extb:
	CP 'B'			;.B ?
	JR NZ,expr_ill
	inc ix
	ld a,(symtyp)
	set 7,a			;Byte einstellen
	ld (symtyp),a
	JR expr_extx
expr_ill:
	dec ix			;Illegal, pointer zurck
expr_extx:
	xor a
	ld a,(symtyp)
	ret  			;hl = ergebnis




;Leerzeichen ignorieren
igbn:			;ix nur veraendern
	ld a,(ix+0) 	;holen des wertes
	cp ' '		;solange space ix erhhen
	jr nz,igbnex
	inc ix
	jr igbn
igbnex:	ret




;Stringende prfen
checkend:
	call igbn 	;muss datenende sein
	or a		;fehler wenn nicht 0
	jr nz,checkenx
	xor a
	ret
checkenx:
	scf
	ret





faktor:		;nach hl faktor holen
		;test erst neue symbole
		;dann feste symbole
		;dann zahlen
		;Optimierung OK

	ld a,(ix+0) 		;erster wert
	cp '-' 			;sign erlaubt
	jr nz,faktor1
	inc ix
	call faktor
	ex de,hl
	ld hl,0
	xor a
	sbc hl,de
	xor a
	ld (symtyp),a 		;kein symbol mehr
	ret
faktor1:
	ld a,1
	ld (symtyp),a 		;user symbol
	ld iy,symtab
	call getsym
	jr nc,faktorx
	ld a,2
	ld (symtyp),a 		;annehmen fix symbol
	ld iy,fixsym
	call getsym
	jr nc,faktorx
	ld a,0 			;konstante wie expr 
	ld (symtyp),a
	ld a,(ix+0) 		;wenn .
	cp '$' 			;einzeln und kein symbol
	jr nz,faktor2
	inc ix 			;next symbol
	ld hl,(startadr) 	;pc stand verwenden in startadr
	xor a
	ret
faktor2:
	call gethl
faktorx:
	ret  			;carry = fehler


; ENDE SYMBOLE
;---------------------------------------------------------------------


;---------------------------------------------------------------------
; ALLGEMEINE UNTERPROGRAMME
; COMMON ROUTINES

gethl:		;muss numerisches zeichen sein
		;eingabe eines zahlenwertes

;Auswertung Vorzeichen
	ld a,(ix+0)
	cp '-' 
	jr nz,gethl1vz
	inc ix
	ld a,1		;fr (sign)
	jr gethl1
gethl1vz:
	cp '+'
	jr nz,gethl2vz
	inc ix  	;+ ignorieren
gethl2vz:
	xor a		;fr (sign)

gethl1:
	ld (sign),a 	;vorzeichenmerker
	ld hl,0  	;ergebniswert

	ld a,(ix+0)	;Aktuelles Zeichen holen
	cp '#' 		;dezimal ?
	jr z,gethldez
	call sedrng
	ret c		;wenn carry dann fehler

gethlslp:		;Schleife HEX Zeichen
	jr c,gethls1	;berspringen wenn nicht SED
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl 	;hl := hl * 16

	call upper	;geht auch
	cp 'F'+1	;A-F
	jr nc,gethlsnum
	cp 'A'
	jr c,gethlsnum
	sub 'A'-10	; vorher: sub 'a' ; add a,10
	jr gethls0
gethlsnum:
	sub '0'		;0-9
gethls0:
	ld c,a
	ld b,0
	add hl,bc	;hl := hl + neuer Wert
	inc ix		
	ld a,(ix+0)	;nchstes Zeichen
	call sedrng 	;checken
	jr gethlslp
	
gethls1:
	xor a  		;kein carry
	jr gethlsgn	;Vorzeichenauswertung


gethldez:
	inc ix  	;war #
	ld a,(ix+0)
	call dezrng
	ret c		;Ausstieg wenn nicht 0-9

gethldlp:		;Schleife DEZ Zeichen
	jr c,gethld1	;Ausstieg wenn nicht 0-9
	ld d,h
	ld e,l
	add hl,hl
	add hl,hl
	add hl,de
	add hl,hl 	;hl := hl * 10
	sub '0' 	;0..9
	ld c,a
	ld b,0
	add hl,bc 	;hl := hl + neuer wert
	inc ix
	ld a,(ix+0)	;nchstes Zeichen
	call dezrng	;checken
	jr gethldlp
gethld1:
	xor a

gethlsgn:
	push af
	ld a,(sign)
	cp 1		;negativ ?
	jr nz,gethlend	;nein, berspringen
	ex de,hl	
	ld hl,0
	xor a
	sbc hl,de	;hl := -hl
gethlend:
	pop af
	ret 




dezrng:			;wenn dezimal [0..9] kein carry
	cp '9'+1
	jr nc,dezerr
	cp '0'
	jr c,dezerr
	scf
	ccf
	ret		;OK, dezimal
dezerr:	scf
	ret		;Fehler



sedrng:			;wenn sedezimal [0..9,A..F,a..f] kein carry
	CP 'F'+1
	JR NC,sed1rng
	CP 'A'+0
	JR NC,sedok
sed1rng:
	CP 'f'+1
	JR NC,sed2rng
	CP 'a'+0
	JR NC,sedok
sed2rng:
	CP '9'+1
	JR NC,sederr
	CP '0'+0
	JR C,sederr
sedok:
	scf
	ccf
	ret		;OK, sedezimal
sederr:	scf
	ret		;Fehler



; laengenbestimmung von befehlen
; hl -> befehl
; b enthaelt nach dem aufruf die anzahl der bytes
; die der Befehl belegt

length:
	ld b,0  	;bytezaehler auf 0 stellen
	ld d,h
	ld e,l
	ld a,(hl)
	and 0dfh 	;dd,fd - Befehle
	cp 0ddh
	jr z,tab5
	ld a,(hl)
	cp 0cbh  	;cb - befehle
	jr z,tab3
	cp 0edh  	;ed - befehle
	jr z,tab2
	ld a,(hl)
	cp 0c3h  	;jmp - befehl
	jr z,b3
	cp 0cdh  	;call - befehl
	jr z,b3
	and 0efh
	cp 022h		;"
	jr z,b3
	cp 2ah		;'
	jr z,b3
	and 0cfh
	cp 1
	jr z,b3  	;ld xx,nn
	and 0c7h
	cp 0c2h  	;jp cond
	jr z,b3
	cp 0c4h  	;call cond
	jr z,b3
	ld a,(hl)
	and 0f7h
	cp 10h  	;djnz , jr
	jr z,b2
	cp 0d3h  	;in , out
	jr z,b2
	and 0e7h
	cp 20h  	;jr cond
	jr z,b2
	and 0c7h
	cp 6  		;ld n
	jr z,b2
	cp 0c6h  	;op n
	jr z,b2
	jr b1  		;rest 1 byte
tab2:
	inc hl
	ld a,(hl)
	and 0c7h
	cp 43h  	;ld (nn), xx ld xx,(nn)
	jr z,b4
	jr b2

tab3:	jr b2	  	;alle 2 bytes
tab4:	jr b4  		;alle 4 bytes

tab5:			;dd,fd
	inc hl
	ld a,(hl)
	cp 0cbh  	;dd,fd cb
	jr z,b4
	cp 21h
	jr z,b4  	;ld ii,nn 
	and 0feh
	cp 34h
	jr z,b3  	;inc dec (ii) 
	and 0f8h
	cp 70h  	;ld (ii),r
	jr z,b3
	ld a,(hl)
	cp 36h  	;auch pseudo
	jr z,b4
	and 0c7h
	cp 6
	jr z,b3
	and 0c7h
	cp 2	  	;ld (nn),ii
	jr z,b4	
	ld a,(hl)
	sub 40h
	and 87h
	cp 6
	jr z,b3  	;ld r,(ii)
	jr b2

b4:	inc b
b3:	inc b
b2:	inc b
b1:	inc b
	ex de,hl 	;alter pointer nach hl
	ret  		;b gueltig anzahl bytes 1..4


; Wait milliseconds in HL
waitms100:
	ld 	hl,100
waitms:
	push	de
w1ms0:
	ld	de,39*4		; 4 MHz
w1ms1:
	dec	de
	ld	a,d
	or	e
	jr	nz,w1ms1
	dec	hl
	ld	a,h
	or	l
	jr	nz,w1ms0
	pop	de
	ret



;---------------------------------------------------------------------



;---------------------------------------------------------------------
; EINZELSCHRITT
; systemaufrufe nicht mit tracen wenn sie von
; einem call aus aufgerufen wurdem


pushall:
	ld (bcsto),bc
	ld (desto),de
	ld (hlsto),hl
	push af
	pop bc
	ld (psw1sto),bc
	ex af,af'
	exx
	ld (bc2sto),bc
	ld (de2sto),de
	ld (hl2sto),hl
	push af
	pop bc
	ld (psw2sto),bc
	ld a,i
	ld (iregsto),a
	ld a,r
	ld (rregsto),a
	ld (rxsto),ix
	ld (rysto),iy
	ld hl,(pcsto) 	;pc stand
	ret


popall:
	ld (pcsto),hl 	;retten hl
	ld iy,(rysto)
	ld ix,(rxsto)
	ld a,(iregsto)
	ld i,a
			; refresh nicht schreiben
	ld bc,(psw2sto)
	push bc
	pop af
	ld hl,(hl2sto)
	ld de,(de2sto)
	ld bc,(bc2sto)
	exx
	ex af,af'
	ld bc,(psw1sto)
	push bc
	pop af
	ld hl,(hlsto)
	ld de,(desto)
	ld bc,(bcsto)
	ret

savegdp:		;bei step, nach init
	push hl
	push bc
	call wait 	;warten bis gdp fertig
	ld c,gdp 	;basisadresse
	ld hl,gdpreg 	;ziel in speicher
	LD b,16  	;alle register retten
savegdplp:
	in a,(c)
	ld (hl),a
	inc c
	inc hl
	djnz savegdplp
	pop bc
	pop hl
	ret

rstoregdp:		;bei step
	push hl
	push bc
	call wait
	ld c,gdp_ctrl1 	;nicht commando
	ld hl,gdpreg+1
	ld b,15
rstoregdplp:
	ld a,(hl)
	out (c),a
	inc c
	inc hl
	djnz rstoregdplp
	pop bc
	pop hl
	ret

befex:			;einen nicht sprungbefehl
			;ausfuehren ueber modber
	ld a,0c3h  	;jp befehl
	ld (modspg),a
	push hl
	ld hl,modr  	;ruecksprungadresse
	ld (modspg+1),hl 
	pop hl
	xor a   	;loeschen rueckw.
	ld b,4
	ld de,modber+3  ;4ter wert
bef1:
	ld (de),a  	;auf 0
	dec de
	djnz bef1
	push de
	call length  	;b=laenge befehl
	pop de
bef2:
	ld a,(hl)  	;hl -> befehl
	inc de
	ld (de),a
	inc hl
	djnz bef2  	;befehl ablegen
	call rstoregdp  	;gdpregister auf user
	call popall  	;register belegen
	ld (syssp),sp  	;retten stackpointer system
	ld sp,(usersp)
	jp modber  	;ausfuehren
modr:			;ruecksprung von mod
	ld (usersp),sp
	ld sp,(syssp)
	call pushall  	;alle register wieder merken
	call savegdp  	;wieder retten neuen stand
	ret   		;schritt ausgefuehrt




rstex:			;rst befehl 
	ld a,(hl)
	inc hl
	ld (syssp),sp
	ld sp,(usersp)
	push hl   	;ablegen aufrufadresse
	ld (usersp),sp
	ld sp,(syssp)
	ld h,0
	and 038h
	ld l,a   	;neuer pc-stand
	ret


callex:
	inc hl
	inc hl
	inc hl   	;ret adr
	ld (syssp),sp
	ld sp,(usersp)
	push hl   	;ret adr dorthin
	ld (usersp),sp
	ld sp,(syssp)
	dec hl
	ld a,(hl)
	dec hl
	ld l,(hl)
	ld h,a   	;sprungziel
	ret


pchlex:
	ld hl,(hlsto)  	;sprung
	ret

pcixex:
	ld hl,(rxsto)
	ret

pciyex:
	ld hl,(rysto)
	ret

retex:
	ld (syssp),sp
	ld sp,(usersp)
	pop hl
	ld (usersp),sp
	ld sp,(syssp)
	ret


jmpex:
	inc hl
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a  	;sprung ausfuehrung
	ret

jrex:
	inc hl
	ld a,(hl)
	inc hl  	;neuer befehl
	ld c,a
	or a  	;flags setzen
	jp m,subjr 	;sprung zurueck
	ld b,0
	add hl,bc 	;pc neu = pc + displ
	ret
subjr:
	ld b,0ffh 	;pc neu = pc +ff displ
	add hl,bc
	ret

djnzex:
	ld bc,(bcsto)
	dec b
	ld (bcsto),bc
	jr nz,jrex 	;ausfuehren sprung
	inc hl
	inc hl
	ret  		;sonst weiter


callcex:		;bedingter upr aufruf
	push hl
	ld hl,callex 	;ohne bedingung
	ld (modber+1),hl
	ld hl,notex
	ld (modber+4),hl 
	ld a,0c3h
	ld (modber+3),a
	pop hl
	ld a,(hl) 	;daraus sprungbef machen
	and 038h
	or 0c2h
	ld (modber),a 	;in modbereich
	ld bc,(psw1sto)
	push bc
	pop af  	;flags gueltig
	jp modber


notex:		;wenn nicht ausgefuehrt
	inc hl
not2ex:
	inc hl
not1ex:
	inc hl
	ret  	;fertig


jmpcex:
	push hl
	ld hl,jmpex 	;ohne bedingung
	ld (modber+1),hl
	ld hl,notex
	ld (modber+4),hl 
	ld a,0c3h
	ld (modber+3),a
	pop hl
	ld a,(hl)
	ld (modber),a 	;befehl direkt
	ld bc,(psw1sto)
	push bc
	pop af
	jp modber

retcex:
	push hl
	ld hl,retex 	;ohne bedingung
	ld (modber+1),hl
	ld hl,not1ex
	ld (modber+4),hl 
	ld a,0c3h
	ld (modber+3),a
	pop hl
	ld a,(hl)
	and 038h
	or 0c2h  	;in sprung umwandeln
	ld (modber),a
	ld bc,(psw1sto)
	push bc
	pop af
	jp modber

jrcex:
	push hl
	ld hl,jrex 	;ohne bedingung
	ld (modber+1),hl
	ld hl,not2ex
	ld (modber+4),hl 
	ld a,0c3h
	ld (modber+3),a
	pop hl
	ld a,(hl)
	and 18h
	or 0c2h
	ld (modber),a 	;als sprung dorthin
	ld bc,(psw1sto)
	push bc
	pop af
	jp modber 	;und ausfuehren


		; Routine STEP fuehrt einen Schritt aus
		; dabei ist hl der aktuelle PC

step:
	ld a,(hl) 	;wichtig ruecksetzen nach step
	cp 0c9h  	;ret befehl
	jp z,retex
	cp 0cdh
	jp z,calltex 	;check ggf in call
	cp 0c3h
	jp z,jmpex
	cp 18h
	jp z,jrex
	cp 010h
	jp z,djnzex
	cp 0e9h
	jp z,pchlex
	and 0e7h
	cp 20h
	jp z,jrcex
	and 0c7h
	cp 0c2h
	jp z,jmpcex
	cp 0c4h
	jp z,calltcex
	cp 0c7h
	jp z,rstex
	cp 0c0h
	jp z,retcex

	ld a,(hl) 	;wert testen
	cp 0edh  	;umschaltbefehle
	jr nz,con2
	inc hl
	ld a,(hl)
	dec hl
	cp 4dh
	jp z,retex 	;reti
	cp 45h
	jp z,retex 	;retn
	jp befex

con2:
	ld a,(hl)
	and 0dfh
	cp 0ddh
	jp nz,befex
	inc hl
	ld a,(hl)
	dec hl
	cp 0e9h
	jp nz,befex
	ld a,(hl)
	cp 0ddh
	jp z,pcixex
	jp pciyex


	; ende step befehl


	;endschleife  nicht als uprg aufrufen, sondern simulieren
	;da kein unterprogramm mit nur einem ausgang


calltcex:
	ld b,3
	call sucheall
	jp nc,befex 	;direkt ausfuehren wenn symbolisch
	jp callcex 	;sonst step durchfuehren



calltex:		;pruefen ob adresse uprg monitor ist
	ld b,3  	;laenge des befehls
	call sucheall 	;hl erhalten  carry=kein symbol
	jp nc,befex 	;einfach direkt ausfuehren dann
	jp callex


; ENDE Einzelschritt
;---------------------------------------------------------------------




;------------------------------------------------------------------
; PROMER ROUTINEN
;	Schneller Programmieralgorithmus

promd 		.equ 80h 		;daten bi-dir
proma1 		.equ 81h 		;lsb adr
proma2 		.equ 82h 		;spez

		; proma2
		; 7    6    5    4    3    2    1    0
		; ena  led  trg  a12  a11  a10  a9   a8
		;
		; bei read
		; 0    1    0
		;
		; bei write
		; 1    0    0
		; 1    0    1
		; 1    0    0
		;
		; proma1 lesen
		; x    x    x    x    x    x    x    bsy
		; bsy=1 bei programmieren sonst 0

#IF optLANG=langDE
promrmsg:
	.word 0,240\	.byte 32h,0\	.text "EPROM lesen"\	.byte 0
pspadr:
	.text "von"\	.byte 0ah
	.text "bis"\	.byte 0ah
	.text "nach"\	.byte 0
#ENDIF
#IF optLANG=langEN
promrmsg:
	.word 0,240\	.byte 32h,0\	.text "Read EPROM"\	.byte 0
pspadr:
	.text "from"\	.byte 0ah
	.text "to"\	.byte 0ah
	.text "dest"\	.byte 0
#ENDIF


promread:		;eprom lesen
	ld a,01000000b 	;prom prg neutral
	out (proma2),a 	;vor aufruf expr
	ld hl,promrmsg
	call textsetaus
	ld ix,pspadr
	call get3par
	ret c  	;fehlerfall
	ld ix,linbuf+8
	call expr
	ret c  	;ziel
	ld (fixadr),hl 	;
	ld hl,(startadr) 	;start adr in prom
	ld de,(startnext) 	;ende incl 0 ff   dest
	ld ix,(fixadr) 	;ziel
lopprom:
	ld a,l  	;lsb
	out (proma1),a
	ld a,h 
	and 00011111b 	;msb max 8K
	or  01000000b 	;lesen
	out (proma2),a
	in a,(promd) 	;data
	ld (ix+0),a 	;ziel ins ram ohne vgl
	push hl
	xor a
	sbc hl,de
	ld a,l
	or h
	pop hl  	;start=ende dann fertig
	ret z  	;ok ende erreicht
	inc ix
	inc hl  	;ziel erhoehen
	jr lopprom

#IF optLANG=langDE
promwmsg:
	.word 0,240\	.byte 32h,0\	.text "EPROM prog"\	.byte 0
#ENDIF
#IF optLANG=langEN
promwmsg:
	.word 0,240\	.byte 32h,0\	.text "Prog EPROM"\	.byte 0
#ENDIF



#IF optLANG=langDE
jamsg:
	.word 0,80\ 	.byte 22h,0\ 	.text "B=Bereit"\ 	.byte 0
pokmsg:
	.word 0,50\ 	.byte 22h,0\ 	.text "OK:  M=Menue"\	.byte 0
pfehmsg:
	.word 0,50\ 	.byte 22h,0\ 	.text "FEHLER:  M=Menue"\ 	.byte 0
#ENDIF
#IF optLANG=langEN
jamsg:
	.word 0,80\ 	.byte 22h,0\ 	.text "R = Ready"\ 	.byte 0
pokmsg:
	.word 0,50\ 	.byte 22h,0\ 	.text "OK:  M = Menu"\	.byte 0
pfehmsg:
	.word 0,50\ 	.byte 22h,0\ 	.text "FAIL:  M = Menu"\ 	.byte 0
#ENDIF


promwrite:		;eprom programmieren
	ld hl,promwmsg
	call textsetaus
	ld ix,pspadr
	call get3par
	ret c  	;fehlerfall
	ld ix,linbuf+8
	call expr
	ret c
	ld (fixadr),hl
	ld hl,jamsg
	call textsetaus
	ld a,01000000b
	out (proma2),a 		;bereit
	call ki  		;lesen
	#IF optLANG=langDE
		cp 'B'  		;wenn B dann weiter
	#ENDIF
	#IF optLANG=langEN
		cp 'R'  		;wenn R dann ready
	#ENDIF
	ret nz  		;sonst abbruch

	ld hl,(startadr) 	;quelle ram
	ld de,(startnext) 	;ende ram
	ld bc,(fixadr)  	;ziel EPROM
	ld a,10000000b
	out (proma2),a 		;tristate
prlp1:
	ld a,(hl) 		;datenwert
	out (promd),a 
	ld a,c
	out (proma1),a 		;ziel in eprom
				; 50 ms Monoflop - Einstellung 
	ld a,b
	and 00011111b
	or  10000000b
	out (proma2),a
	or  00100000b 		;prg
	out (proma2),a
	and 11011111b
	out (proma2),a 		;neutral
	push hl
	push de
	push bc
	push bc

L168:
	call sync
	JP C,L168
	ld hl,250 	;fuer flickerfreies Bild
	ld de,80
	ld a,22h 	;adr
	call setausbuf
	pop hl  	;ziel in eprom
	call prthl
	ld hl,ausbuf
	call textsetaus
	pop bc
	pop de
	pop hl

L169:
	call sync	; gesamt 60ms
	JP C,L169	;damit 80% zyklus
L170:
	call sync 	;somit c bei monoflop 
	JP C,L170	;wieder entladen

	push hl
	xor a
	sbc hl,de 	;start-ende
	ld a,l
	or h
	pop hl 
	jr z,prgfin 	;CHECK nach brennen
	inc hl
	inc bc  	;ziel,quelle erhoehen
	jr prlp1 	;weiter bis fertig

prgfin:
	ld a,01000000b
	out (proma2),a 
	ld hl,(startadr) 	;start ram
	ld de,(startnext) 	;ende ram
	ld bc,(fixadr) 		;ziel eprom

prglp4:
	ld a,c
	out (proma1),a
	ld a,b
	and 00011111b
	or  01000000b
	out (proma2),a
	in a,(promd)
	cp (hl) 		;muss gleich sein
	jr nz,prgnfin 		;fehler
	push hl
	xor a
	sbc hl,de
	ld a,l
	or h
	pop hl
	jr z,okfin
	inc hl
	inc bc
	jr prglp4

prgnfin:
	ld hl,pfehmsg
	jr pskip1

okfin:
	ld hl,pokmsg
pskip1:
	call csts 		;wenn vorher gedrueckt loeschen
	jr z,pskip1o
	call ki 		;dummy einlesen
pskip1o:
	call textsetaus 
L171:
	call ki
	CP 'M'
	JP NZ,L171
	ret

		

; PROMER ENDE
;------------------------------------------------------------------



#IF optSAVE=saveCAS
;------------------------------------------------------------------
; ROUTINEN CAS
;	CAS Routinen nicht optimiert

; Kassettenformat
;  FF FF FF FF FF 00 / name 0D FF FF FF FF
;  00 : startmsb startlsb endmsb endlsb  data ... checkmsb checklsb FF FF FF
;  00 $ wie vorher jedoch fuer symbole

ladcas:
	xor a
	ld hl,ladcasmsg
	jr lesecas
pruefcas:
	ld hl,pruefmsg
	ld a,1
lesecas:			;a=0 laden a=1 prueflesen
	ld (merkcas),a 		;merker
	call textsetaus 
	ld hl,20
	ld de,128
	ld a,22h 		;name aus
	call setausbuf 		;definieren und ix
		  		;ff ff ff ff 0 /
L173:	call ri
	CP 0ffh 		;start zeichen
	Jr NZ,L173

L174:	call ri			;frame start
	OR A
	Jr NZ,L174
	
	call ri			;name beginn
	CP '/' 
	Jr NZ,L173

	call ri			;name lesen
L175:	CP  0dh
	Jr Z,L176
	ld (ix+0),a
	inc ix
	call ri
	Jr L175

L176:	ld (ix+0),0 		;stop zeichen
	ld hl,ausbuf
	call textsetaus 	;name ausgeben
	ld c,':' 		;kennung
	call readcas
	Jr C,L177
	ld c,'$'
	call readcas
L177:	call textsetaus 	;meldung ok etc

L178:	call ki
	CP 'M'
	Jr NZ,L178
	ret


readcas:		; c = Kennung
	call ri			; Zeichen von CAS lesen
	or a			; bis 00h
	jr nz,readcas
	call ri			; Startframe abwarten
	cp c
	jr nz,readcas

	ld hl,0  		; pruefsumme nach DE
	call ri
	ld d,a
	call ri
	ld e,a
	ld (startadr),de 	; Pruefsumme sichern
	add hl,de
	push de  		; Startadr nach DE
	call ri
	ld d,a
	call ri
	ld e,a
	ld (startnext),de 	; Startadresse sichern
	add hl,de
	pop de  		; start adresse


	PUSH HL			; LOOP
	LD HL,L181
	EX (SP),HL

L182:
	call ri 		; Daten lesen, mind 1 Byte
	ld c,a			; in C sichern
	ld b,0 
	add hl,bc 		; Pruefsumme bilden

	ld a,(merkcas)		; Laden oder Prfen ?
	or a
	jr nz,L183

	ld a,c			; Daten zurckholen
	ld (de),a		; am Ziel speichern 

L183:
	ld a,(de) 		; Inhalt von Adresse
	cp c			; mit Daten vergleichen
	jr z,L184		; Wenn OK weiter
	scf  			; Fehlerflag 
	ret			; Sprung nach L181

L184:
	push hl
	ld hl,(startnext)
	xor a
	sbc hl,de
	ld a,h
	or l
	pop hl
	jr nz,L185
	xor a
	ret			; Fertig, Sprung nach L181

L185:
	inc de  		; nchste Adresse
	jr L182			; nchstes Byte lesen

L181:
	ex de,hl 		; Pruefsumme nach de
	ld hl,okmsg
	jr nc,rdc1		; Carry testen
	ld hl,vermsg		; Fehlermeldung Verify ausgeben
	ret
rdc1:
	call ri
	cp d  			; Pruefsumme LSB testen
	jr z,rdc2
	ld hl,summsg		; Prfsummenfehler melden
	scf
	ret
rdc2:
	call ri
	cp e			; Pruefsumme MSB testen
	jr z,rdc3
	ld hl,summsg		; Pruefsummenfehler melden
	scf
	ret
rdc3:
	xor a  			; Prfsumme OK, Ende ohne Carry
	ret



#IF optLANG=langDE
okmsg:	.word 80,50\	.byte 22h,0\	.text "OK:  M=Menue"\		.byte 0
summsg:	.word 80,50\	.byte 22h,0\	.text "SUMME:  M=Menue"\	.byte 0
vermsg:	.word 80,50\	.byte 22h,0\	.text "FEHLER:  M=Menue"\	.byte 0

ladcasmsg:
	.word 0,240\	.byte 32h,0\	.text "Laden CAS"\		.byte 0
pruefmsg:
	.word 0,240\	.byte 32h,0\	.text "Pruefen CAS"\		.byte 0
speichmsg:
	.word 0,240\	.byte 32h,0\	.text "Speichern CAS"\		.byte 0
spfill:
	.text "Start"\ .byte 0ah
	.text "Ende"\ .byte 0ah
	.text "Name"\ .byte 0
#ENDIF

#IF optLANG=langEN
okmsg:	.word 80,50\	.byte 22h,0\	.text "OK:  M = Menu"\		.byte 0
summsg:	.word 80,50\	.byte 22h,0\	.text "CHKSUM:  M = Menu"\	.byte 0
vermsg:	.word 80,50\	.byte 22h,0\	.text "FAIL:  M = Menu"\	.byte 0

ladcasmsg:
	.word 0,240\	.byte 32h,0\	.text "Load CAS"\		.byte 0
pruefmsg:
	.word 0,240\	.byte 32h,0\	.text "Verify CAS"\		.byte 0
speichmsg:
	.word 0,240\	.byte 32h,0\	.text "Save CAS"\		.byte 0
spfill:
	.text "Start"\ .byte 0ah
	.text "End"\ .byte 0ah
	.text "Filename"\ .byte 0
#ENDIF


speichcas:
	ld hl,speichmsg
	call textsetaus
	ld ix,spfill
	call get3par
	ret c  			;fehler ausgang

	LD b,40
L186:
	ld c,0ffh 		;sync zeichen
	call poo
	djnz L186

	ld c,0
	call poo
	ld c,'/' 		;name folgt
	call poo
	ld ix,linbuf+8 		;name dort

L187:	LD A,(ix+0)
	OR A
	Jr Z,L188		;bis (ix+0)=0
	ld c,(ix+0)
	inc ix
	call poo
	Jr L187

L188:	ld c,0dh
	call poo 		;ende name
	ld c,':' 		;kennung
	call writecas 		;staradr bis endadr

	ld hl,symanz 		;startadresse
	ld (startadr),hl
	ld hl,(symptr) 		;next free inclusive
	ld (startnext),hl
	ld c,'$' 		;symboltabelle
	call writecas 		;hl = start de = stop

	LD b,20
L189:	ld c,0ffh
	call poo
	djnz L189
	ret  			;fertig


writecas:
	push bc 		;c=kennung

	LD b,20
L190:	ld c,0ffh
	call poo
	djnz L190

	ld c,0
	call poo
	pop bc  		;kennung
	call poo
	ld hl,0 		;checksum

	ld de,(startadr)
	add hl,de
	push de
	ld c,d
	call poo
	ld c,e
	call poo 		;ausgabe

	ld de,(startnext)
	add hl,de
	ld c,d
	call poo
	ld c,e
	call poo 		;ausgabe endadr
	pop de  		;startadr

	PUSH HL			; Schleifenbeginn
	LD HL,L191
	EX (SP),HL

L192:
	ld a,(de) 		;laden wert
	ld c,a
	ld b,0
	add hl,bc 		;checksum
	call poo 		;ausgabe

	push hl
	ld hl,(startnext)
	xor a
	sbc hl,de
	ld a,h
	or l
	pop hl
	RET Z			;Sprung nach L191

	inc de 			;naechste stelle
	Jr L192

L191:	ld c,h
	call poo 
	ld c,l
	call poo 		;pruefsumme aus
	ret

; ENDE CAS ROUTINEN
;------------------------------------------------------------------
#ENDIF



;------------------------------------------------------------------
; IO ROUTINEN

#IF optLANG=langDE
iomsg:	.word 0,240\	.byte 32h,0\	.text "IO lesen"\	.byte 0
io1msg:	.word 0,0\	.byte 21h,0\	.text "R=Adr  D=Dauer  S=Stop  M=Menue"\	.byte 0
#ENDIF
#IF optLANG=langEN
iomsg:	.word 0,240\	.byte 32h,0\	.text "Get Port"\	.byte 0
io1msg:	.word 0,0\	.byte 21h,0\	.text "R = Addr  C = Cont  S = Stop  M = Menu"\		.byte 0
#ENDIF

ioread:
	ld hl,iomsg
	call textsetaus
	ld hl,io1msg
	call textsetaus
	call getadr 		;adresse port holen
	ret c  			;bei fehler zurueck in hauptmenue
	ld c,l  		;port adresse
io1rd:
	push bc
	call ioprint 		;ausgabe 
	call ki
	pop bc  		;c=portadresse
#IF optLANG=langDE
	cp 'D'			;DAUER
#ENDIF
#IF optLANG=langEN
	cp 'C'			;CONTINUOUS
#ENDIF
	jr nz,io1single		

io1dauer:
	push bc
	call sync
	jr c,io1dauer1
	call ioprint
io1dauer1:
	call csts		;Taste vorhanden?
	CP 0ffh
	jr nz,io1dauer2
	call ki			;wenn ja einlesen
io1dauer2:
	pop bc
	cp 'S'			;STOP
	jr z,io1single
	cp 'M'			;MENUE
	jr z,io1single
	cp 'R'			;ADR
	jr nz,io1dauer		;weiter bis Taste in S,M,R
io1single:
	cp 'M' 			;zum Menue
	ret z
	cp 'R'			;neue Adresse
	jr z,ioread
	jr io1rd 		;von vorn


ioprint:			;inhalt angeben
	push bc  		;c=portadresse
	ld hl,200
	ld de,150
	ld a,22h
	call setausbuf		;buffer vorbereiten
	pop bc
	
	in a,(c) 		;wert holen
	push af
	call prtac		;hex
	call blank
	ld a,'='
	call zeich
	call blank
	pop af
	call prtbin		;bin
	ld hl,ausbuf
	call textsetaus		;Ausgabe: HEX = BIN
	ret


#IF optLANG=langDE
iopmsg:		.word 0,240\	.byte 32h,0\	.text "IO setzen"\	.byte 0
datamsg:	.word 20,150\	.byte 22h,0\	.text "Daten"\		.byte 0
iop1msg:	.word 0,0\	.byte 21h,0\	.text "M=Menue  R=Adr"\	.byte 0
#ENDIF
#IF optLANG=langEN
iopmsg:		.word 0,240\	.byte 32h,0\	.text "Set Port"\	.byte 0
datamsg:	.word 20,150\	.byte 22h,0\	.text "Data"\	.byte 0
iop1msg:	.word 0,0\	.byte 21h,0\	.text "M = Menu  R = Addr"\	.byte 0
#ENDIF

iowrite:
	ld hl,iopmsg
	call textsetaus
	call getadr 
	ret c  			;l=adresse port
	ld c,l
	push bc

	ld hl,datamsg
	call textsetaus
	ld hl,90
	ld de,150
	ld a,22h
	ld b,30
	call textxy

	ld ix,linbuf+8
	call expr

	pop bc
	ret c  			;fehler
	out (c),l 		;ausgabe der werte
	ld hl,iop1msg
	call textsetaus
iopw1:
	call ki  		;zeichen
	cp 'R'
	jr z,iowrite 		;nochmals
	cp 'M' 
	ret z			;Menue
	jr iopw1


; ENDE IO ROUTINEN
;------------------------------------------------------------------



;------------------------------------------------------------------
; SYMBOLAUSGABE
;	123456789012345678901234567890123456789012
;	Adr  Symbol           Adr  Symbol
;	0000 12345678901234   0000 12345678901234

#IF optLANG=langDE
symmsg1:	.word 0,240\	.byte 32h,0\	.text "Symbole"\	.byte 0
symmsg2:	.word 0,220\	.byte 21h,0\	.text "cr=weiter  N=Nochmal  M=Menue"\	.byte 0
symmsg3:	.word 0,180\	.byte 22h,0\	.text "keine definiert"\	.byte 0
#ENDIF
#IF optLANG=langEN
symmsg1:	.word 0,240\	.byte 32h,0\	.text "Symbols"\	.byte 0
symmsg2:	.word 0,220\	.byte 21h,0\	.text "cr = Page  A = Again  M = Menu"\	.byte 0
symmsg3:	.word 0,180\	.byte 22h,0\	.text "no Symbols"\	.byte 0
#ENDIF


symaus:			;Symbole ausgeben
	ld iy,symtab 		;eigene symbole zuerst ausgeben
symaus1:
	push iy			;retten
	call clrall
	ld hl,symmsg1
	call textsetaus 	;header ausgeben
	ld hl,symmsg2
	call textsetaus		;menue ausgeben

	pop iy  		;pointer symbole
	ld a,(iy+0)		;Tabelle leer?
	or a
	jr nz,symausok		;zur Ausgabe
	ld hl,symmsg3		;Message
	call textsetaus
	jr symaus2		;zur Tastenabfrage

symausok:
	ld b,8			;8 Symbole in Col 1
	ld hl,0
	call syma1 		;hl = x koordinate

	jr c,symaus2		;bei Carry berspringen 
	ld b,8 			;6 Symbole in Col 2
	ld hl,264
	call syma1

symaus2:
	call ki			;Tastenauswertung
	and 7fh
	cp 'M' 
	ret z			;zurck zum Menue
#IF optLANG=langDE
	cp 'N'			; Nochmal
#ENDIF
#IF optLANG=langEN
	cp 'A'			; Again
#ENDIF
	jr z,symaus		;nochmal von vorn
	cp 13
	jr z,symaus1		;nchste Seite
	jr symaus2


; Eine Spalte mit Symbolen ausgeben
; 	b  = Anzahl auszugebender Symbole 
; 	hl = xposition
; 	iy = pointer Symboltabelle

syma1:
	ld (ausbuf+0),hl 	; x position in Ausgabebuffer
	ld hl,180
	ld (ausbuf+2),hl	; y position in Ausgabebuffer
	ld a,22h
	ld (ausbuf+4),a		; size in Ausgabebuffer
	xor a
	ld (ausbuf+5),a		; ital in Ausgabebuffer

symaloop:
	ld a,(iy+0)		; Zeichen aus Symboltabelle holen
	or a
	jr z,symaexit		; EXIT wenn Ende der Tabelle

	;maximal 14 Zeichen eines Symbols bertragen in ausbuf

	ld ix,ausbuf+11		; Position fr Symbol-String
	ld e,14			; max anzahl
symachar:
	ld a,(iy+0)		; Zeichen aus Symboltabelle
	ld (ix+0),a		; in Ausgabepuffer
	res 7,(ix+0)		; Ende-Kennung Symbol zurcksetzen
	dec e			; Zeichen zhlen
	jr z,symachar1
	inc ix			; Pointer erhhen
	inc iy
	bit 7,a			; war Endekennung Symbol?
	jr z,symachar		; nein, nchstes Zeichen
	jr symawert		; ja, weiter
symachar1:			; bereits 14 Zeichen bertragen
	bit 7,(iy+0)		; Symbol Endekennung prfen
	inc iy			; Symbolpointer erhhen
	jr z,symachar1		; bis Ende Symbol berlesen

	;Wert in ausbuf bertragen

symawert:
	ld (ix+0),0		; Endekennung in Ausgabebuffer
	ld l,(iy+0)		; LSB Wert lesen
	inc iy
	ld h,(iy+0)		; MSB Wert lesen
	inc iy			; zeigt auf nchstes Symbol oder Ende

	;Ausgabe wert und Symbol

	push iy			; retten Symbolzeiger
	push bc			; retten Counter
	ld ix,ausbuf+6		; Pointer fr Wert
	call prthl		; Wert in Ausgabebuffer
	ld (ix+0),' '		; Endekennung von Wert wegnehmen
	ld hl,ausbuf
	call textsetaus		; Ausgabe des Labels

	;Position nchste Zeile bestimmen

	ld hl,(ausbuf+2)	; YPos holen
	ld bc,20		; Abstand
	xor a			; wegen SBC, Carry lschen
	sbc hl,bc		; YPos verringerm
	ld (ausbuf+2),hl	; neu setzen
	pop bc			; Counter wiederholen
	pop ix			; Pointer wiederholen

	djnz symaloop		; bis alle Symbole behandelt oder Exit
	ret			; Spalte fertig

symaexit:			; Ende der Symboltabelle erreicht
	ld iy,symtab		; Pointer wieder auf Anfang
	scf			; Carry gesetzt
	ret			; Fertig

; ENDE SYMBOLAUSGABE
;------------------------------------------------------------------





;------------------------------------------------------------------
; SPEICHER NDERN

; Funktion original
;	Eingabe der Adresse mit Symbolen mglich
;	Setzen von symbolen: 	"loop := 8c00" spaces notwendig
;	Eingabe von Befehlen: 	"cd schreite" fixe symbole
;				"22 loop" eigene symbole



; Untersttzungsfunktionen


;Suche, ob an Adresse ein Symbol definiert ist
sucheall:			;hl=cd-befehl  oder wort-befehl
	push hl  		;hl,ix erhalten
	push de  		;laenge -2 + n
	ld e,b   		;b = anzahl bytes 
	ld d,0
	dec de
	dec de   		;mus 4 oder 3 sein
	add hl,de  		;carry wenn nicht gefunden
	ld e,(hl)         	;lsb    sonst iy name
	inc hl
	ld d,(hl)
	ld iy,symtab         	;user befehle zuerst
	ex de,hl
	push hl  		;adr
	call suchadr
	pop hl
	jr nc,sucheend
	ld iy,fixsym		;dann fixe symbole
	call suchadr		;carry dann kein symbol
sucheend:
	pop de
	pop hl  		;start adresse
	ret


suchadr:		;hl = wert gesucht ist in
			;iy pointer auf name des symboles
			;dazu iy vorbelegt mit symboltabellenindex
			;carry  wenn symbol nicht gefunden

	ex de,hl 		;de ist nun vergleichswert

suchadrlp:
	ld (susymind),iy 	;merken start des symbols
	ld a,(iy+0)		;bei (iy)=0 Ende der Tabelle
	or a
	jr nz,suchadrcnt
	scf			;Carry setzen, nicht gefunden
	jr suchadrx

suchadrcnt:
	bit 7,(iy+0)		;iy++ bis bit 7 gesetzt
	inc iy
	jr z,suchadrcnt

	ld l,(iy+0)		
	inc iy
	ld h,(iy+0)
	inc iy
	xor a
	sbc hl,de 

	ld a,l			;hl = 0?
	or h
	jr nz,suchadrlp		;weiter suchen
	xor a  			;ok gefunden kein carry
suchadrx:
	ld iy,(susymind) 	;start letztes symbol
	ret



adrcheck:		;start adr = hl  laenge=b
	push bc
	ld a,(hl)
	and 11011111b 	;fd,dd Befehlsgruppe
	cp $dd
	jr nz,adr1c
	dec b
adr1c:
	ld a,(hl)
	cp $ed		;ed Befehlsgruppe
	jr nz,adr2c
	dec b  		;n=3 ist ok, b=laenge
adr2c:
	ld a,b		;nur bei ld (ix+n),n 
	cp 3  
	jr nz,adr3c
	scf  		;Carry, nicht adresse
	pop bc
	ret
adr3c:
	xor a		;kein Carry, Adresse
	pop bc
	ret



befprint:
	call prthl  	;start adr ausgeben
	call blank
	ld a,':'
	call zeich  	;trennzeichen
	call length  	;befehlslaenge mind 1 in b
	push hl
	push bc
	call prtbytes  	;xxxx : dd dd dd dd
	pop bc 
	pop hl

;check, ob label ausgeben werden muss

	call adrcheck  	;befehl analyse
	jr nc,befprx	;carry = befehlsgruppe
			;nur bei wort-befehlen b=laenge

	call sucheall  	;hl=befehl cd start
	jr c,befprx	;carry = nicht gefunden
			;iy = symbol wenn kein carry

;label ausgeben
	call blank
	ld a,7ch  	;trennzeichen |
	call zeich  	;xxxx : dd dd dd | dd name (nicht bei ix,iy)
	call blank
	ld a,(hl)  	;befehlswert
	call prtac
	call blank
	
	ld a,(hl)  	;=fd,dd,ed ? dann noch ein byte
	cp 0ddh
	jr z,bef0pr
	cp 0fdh
	jr z,bef0pr
	cp 0edh
	jr nz,bef3pr

bef0pr:			; DD FD ED
	inc hl		;nchste Adresse
	ld a,(hl)	;Byte holen
	call prtac	;in Buffer
	call blank	;Leerzeichen

bef3pr:
	inc hl
bef1pr:
	ld a,(iy+0)	;Zeichen aus Symboltabelle holen
	and 7fh		;ASCII maskieren
	ld (ix+0),a	;in Ausgabebuffer bertragen
	bit 7,(iy+0)	;Endekennung?
	inc ix		;Pointer erhhen
	inc iy
	jr z,bef1pr	;weiter bis Symbol bertragen

befprx:	
	ld b,40  	;rest auffuellen mit leerzeichen
bef2pr:	
	call blank  	;um alten teil zu loeschen
	djnz bef2pr

	ld hl,ausbuf	;Adresse Buffer holen
	call textsetaus	;Zeile ausgeben
	ret



#IF optLANG=langDE
prgmsg:		.word 0,240\	.byte 32h,0\	.text "MEM aendern"\	.byte 0
prgmsg2:	.word 0,16\	.byte $21,0
		.text "+=Adr+1   -=Adr-1   cr=Befehl weiter"\	.byte 0
prgmsg3:	.word 0,0\	.byte $21,0\	.text "M=Menue  R=Adr"\	.byte 0
#ENDIF
#IF optLANG=langEN
prgmsg:		.word 0,240\	.byte 32h,0\	.text "Edit MEM"\	.byte 0
prgmsg2:	.word 0,16\	.byte $21,0
		.text "+ = Addr+1  - = Addr-1  cr = next Instr"\	.byte 0
prgmsg3:	.word 0,0\	.byte $21,0\	.text "M = Menu  R = Addr"\	.byte 0
#ENDIF


progmod:
	ld hl,prgmsg		;Titel ausgeben
	call textsetaus
	ld hl,prgmsg2		;Submen ausgeben
	call textsetaus
	ld hl,prgmsg3		;Submen ausgeben
	call textsetaus

	call getadr		;Adresse abfragen
	ld (startadr),hl 	;temp speicher
	ld (startold),hl 	;beide auf diese adresse

progloop:			;Schleifenbeginn

	ld hl,(startadr)
	call length		;befehlslnge ermitteln
	ld c,b
	ld b,0
	add hl,bc
	ld (startnext),hl	;merken nchste befehlsadresse

	ld hl,20		;buffer textausgabe einrichten
	ld de,165
	ld a,22h
	call setausbuf
	
	ld hl,(startold)	;wenn hl <> 0 dann
	call befprint		;Ausgabe Befehl
	
	ld hl,20		;buffer textausgabe vorbereiten
	ld de,145		;Zeile 1
	ld a,22h
	call setausbuf
	
	ld hl,(startadr)
	ld (startold),hl
	call befprint  		;hl=adresse befehl 
	
	ld hl,20		;buffer textausgabe vorbereiten
	ld de,125		;Zeile 2
	ld a,22h
	call setausbuf
	
	ld hl,(startnext)
	call befprint

	ld hl,20		;buffer textausgabe vorbereiten
	ld de,100		;Zeile 3
	ld a,22h
	call setausbuf

	ld hl,(startadr)	;Adresse ausgeben
	call prthl
	ld hl,ausbuf
	call textsetaus

	ld hl,92		;Eingabebuffer vorbereiten
	ld de,100
	ld a,22h
	ld b,30
	call textxy 		;Eingabe von befehl
	

	ld a,(linbuf+7)		;Adresse Eingabebuffer Zeichenzahl???
				;0 Zeichen: wie <cr> betrachten
				;1 Zeichen: holen -> Grobuchstaben 
	or a
	jr nz,prog1mod
	ld a,0dh		;<cr> simulieren
	jr prog1key		;zur Tastenauswertung

prog1mod:
	cp 1			;mehr als 1 Zeichen?
	jr nz,progcont		;Tastenauswertung berspringen
	ld a,(linbuf+8)		;Zeichen holen
	call upper		;Groschrift wegen Tastenauswertung


; Tastenauswertung
prog1key:
	cp '+'
	jr nz,prog2key
	ld hl,(startadr)	;Adresse ++
	inc hl
	ld (startadr),hl
	jp progloop
prog2key:
	cp '-'
	jr nz,prog3key
	ld hl,(startadr)	;Adresse --
	dec hl
	ld (startadr),hl
	dec hl
	ld (startold),hl 	;vorgaenger zeigen
	jp progloop
prog3key:
	cp 0dh
	jr nz,prog4key
	ld hl,(startadr)	;Adresse + beflen
	call length
	ld c,b
	ld b,0
	add hl,bc 
	ld (startadr),hl
	jp progloop
prog4key:
	cp 'M'
	jr nz,prog5key
	ret			;--> Menue
prog5key:
	cp 'R'
	jr nz,prog6key
	call getadr		;Neue Adresse holen
	ld (startadr),hl
	jp progloop	
prog6key:
;tastenauswertung ende


;Eingabe analysieren
progcont:
	ld ix,linbuf+8
	call igbn		;blanks berlesen
	ld a,(ix+0)
	cp 22h			;text start? (" oder ')
	jr z,progtext
	cp 27h
	jr nz,progsymb		;ja, symbol einlesen


;Text analysieren
progtext:
	ld (merkzeich),a
	inc ix
	ld iy,(startadr)
prog1cont:			;Schleife ber Eingabezeile
	ld a,(merkzeich)
	cp (ix+0)		;Zeilenende Terminator ?
	jr z,prog2cont
	ld a,(ix+0)
	cp 7fh+1		;Zeichen > 7Fh ?
	jr nc,prog2cont
	cp 20h			;Zeichen < 20h ?
	jr c,prog2cont
	ld (iy+0),a		;Zeichen bertragen
	inc ix			;Pointer erhhen 
	inc iy    
	jr prog1cont		;Bis ende
prog2cont:
	ld (startadr),iy
	jr proglp	


;Symbol analysieren
progsymb:
	ld ix,linbuf+8
	call assign 		;ggf definition
	jp nc,progloop		;fertig wenn kein carry
	ld ix,linbuf+8 		;sicherheitshalber zurueck
	call expr 		;ix gueltig hl=wert a=parameter type
	ld iy,(startadr)

prog1symb:			;Schleife
	jr c,prog4symb
	ld (iy+0),l		;Byte ablegen
	inc iy
	bit 7,a 		;=1 dann byte sonst wort 
	jr nz,prog2symb
	ld (iy+0),h		;Wort ablegen   
	inc iy 			
prog2symb:
	call igbn 		;ok auch moeglich 1.6
	ld a,(ix+0) 		;komma ist trennzeichen
	cp ','
	jr nz,prog3symb
	inc ix
prog3symb:
	push iy
	call expr
	pop iy
	jr prog1symb
prog4symb:
	call checkend 		;nur wenn ende ok
	jr c,proglp
	ld (startadr),iy

proglp:	jp progloop		;zurck zur Hauptschleife


; ENDE SPEICHER NDERN
;------------------------------------------------------------------



;------------------------------------------------------------------
; EINZELSCHRITT


#IF optLANG=langDE
stpmsg:	
	.word 0,240\	.byte 32h,0\	.text "Einzelschritt"\	.byte 0
#ENDIF
#IF optLANG=langEN
stpmsg:	
	.word 0,240\	.byte 32h,0\	.text "Trace"\	.byte 0
#ENDIF

regmsg:
	.word 0,10
	.byte 11h,0
	.text "af   bc   de   hl   af'  bc'  de'  hl'  ix   iy   sp   i  r"
	.byte 0

regprint:		;ausgabe registerinhalte
	ld hl,regmsg
	call textsetaus
	ld hl,0
	ld de,0
	ld a,11h
	call setausbuf
reg1print:
	ld hl,psw1sto 	;von da ab 11 register
	ld b,11  
reg1prlp:
	push bc
	inc hl
	ld a,(hl) 	;msb first
	dec hl
	call prtac
	ld a,(hl) 	;lsb
	inc hl
	inc hl
	call prtac
	call blank 	;leerzeichen
	pop bc
	djnz reg1prlp

	ld a,(hl) 	;i
	inc hl
	call prtac
	call blank
	ld a,(hl)
	call prtac 	;r
	ld hl,ausbuf
	call textsetaus 	;und ausgeben
	ret


stpprint:
	ld a,(wrtpage)
	push af
	ld a,2
stpprint1:
	push af
	dec a  			;1,0
	ld (wrtpage),a
	call aktpage
	call setpen 		;setzmode
	call stp1prt
	pop af
	dec a
	jr nz,stpprint1
	pop af
	ld (wrtpage),a
	ret


stp1prt:
	call regprint 		;register
	ld hl,340
	ld de,20
	ld a,11h
	call setausbuf
	ld hl,(pcsto) 		;start dort
	call befprint 		;befehl ausgeben
	ld hl,stp1msg
	call textsetaus
	ret

#IF optLANG=langDE
stp1msg:
	.word 0,20\ 	.byte 11h,0
	.text "R=Adr  S=Seite  N=n-Mal  B=Bis  cr=Ausfuehren  M=Menue"\ 	.byte 0
#ENDIF
#IF optLANG=langEN
stp1msg:
	.word 0,20\ 	.byte 11h,0
	.text "R=Addr  P=Page  N=Repeat  T=To  cr=Execute  M=Menu"\ 		.byte 0
#ENDIF


stepstart:			;einzelschritt ausfuehren
	xor a
	ld (viewpage),a
	ld (wrtpage),a
	call aktpage
	ld hl,retadr 		;nach progstart menue im fehler
	ld (speichend-1),hl 	;dorthin ret adresse
	ld hl,speichend-1
	ld (usersp),hl 		;default ans ende 
	ld hl,stpmsg
	call textsetaus
	call getadr 		;adresse start pc holen
	ret c  			;ungueltige adresse
	ld (pcsto),hl 		;dort ablegen
	call setupturt 		;loeschen bildschirm und marke 
stp1:
	call stpprint 		;ausgabe register
	call ki 		;zeichen holen
	cp 0dh
	jr nz,stp2
	call stepex
	jp c,retadr 		;ende aus grundmode heraus
	jr stp1
stp2:
	cp 'R'
	jr z,stepstart 		;wieder zurueck
#IF optLANG=langDE
	cp 'S'			;SEITE
#ENDIF
#IF optLANG=langEN
	cp 'P'			;PAGE
#ENDIF
	jr z,seitestp 		;auswahl seite
	cp 'N'  		;n mal steppen
	jr z,nstep
#IF optLANG=langDE
	cp 'B'			;BIS
#ENDIF
#IF optLANG=langEN
	cp 'T'			;TO
#ENDIF
	jr z,bisstep 
	cp 'M'
	jr nz,stp1 		;falsche eingabe
	jp finalprg 		;ende ausfuehrung 
				;dort ruecksetzen flip-mode etc


stepex:
	ld hl,(pcsto) 		;nicht bei retadr dann STOP
	ld de,retadr
	xor a
	sbc hl,de
	ld a,h
	or l
	scf
	ret z  			;=0 dann carry ausgang
	ld hl,(pcsto)
	call step
	ld (pcsto),hl
	xor a  			;normal termination
	ret



seitestp:
	call getadrstp
	jr nc,seitestp1
	ld a,1 			;flip on
	ld (flip),a
	ld (flipcnt),a
	jr seitestp2
seitestp1:
	xor a
	ld (flip),a 		;ohne flip, nur ansehen
	ld a,l
	and 3
	ld (viewpage),a
	ld (wrtpage),a
	call aktpage
seitestp2:
	jr stp1



nstep:
	call getadrstp
	jr c,stp1 		;fehler zurueck
nstepwdh:
	push hl
	call stepex
	pop hl
	jp c,retadr 		;ende
	dec hl
	ld a,l
	or h
	jr nz,nstepwdh
	jp stp1


bisstep:
	call getadrstp
	jp c,stp1 		;fehler
biwdhl:
	push hl			;ersten ausfuehren
	call stepex
	pop hl
	jp c,retadr	 	;ende bedingung ABBRUCH
	push hl
	ld de,(pcsto)
	xor a
	sbc hl,de
	ld a,h
	or l
	pop hl
	jr nz,biwdhl
	jp stp1


getadrstp:
	ld a,0
	ld (viewpage),a
	ld (wrtpage),a
	call aktpage
	ld hl,5
	ld de,240
	ld a,11h
	ld b,30
	call textxy 		;eingabe text
	ld ix,linbuf+8
	call expr
	ret


; EINZELSCHRITT ENDE
;------------------------------------------------------------------




;------------------------------------------------------------------
; PROGRAMM STARTEN

; starten eines anwenderprogramms
; flip vorbelegung erst nach grap-aufruf

#IF optLANG=langDE
prstmsg:
	.word 0,240\	.byte 32h,0\	.text "Programm starten"\	.byte 0
#IF optFLIP = autoEXEC
qmsg:
	.word 420,245\	.byte 11h,0\	.text "F=Flip  M=Menue"\	.byte 0
#ENDIF
#ENDIF
#IF optLANG=langEN
prstmsg:
	.word 0,240\	.byte 32h,0\	.text "Execute"\		.byte 0
#IF optFLIP = autoEXEC
qmsg:
	.word 395,245\	.byte 11h,0\	.text "F = Flip   M = Menu"\	.byte 0
#ENDIF
#ENDIF

progstart:			;system stackpointer verwenden fuer user
				;ueberschrift ausgeben zuerst
	ld hl,prstmsg
	call textsetaus
	call getadr
	ret c  			;zurueck ins menue wenn fehler
				;hl = startadresse benutzerprogramm 
	call checkend 		;muss terminiert sein
	ret c  			;sonst nicht ausfuehren
	call setupturt	 	;marke definieren
	ld de,retadr 		;zurueck hierhin
	push de
	jp (hl) 		;ausfuehren userprog 

				;auch bei fehler singlestep
retadr:				;ruecksprung
	xor a
	ld (viewpage),a
	ld (wrtpage),a
	call aktpage

#IF optFLIP != autoEXEC
	call ki			; Warten auf Keypress
finalprg:
	ret
#ENDIF

#IF optFLIP = autoEXEC
	ld hl,qmsg		; F=Flip M=Menue
	call textsetaus
proglp0:			; F und M auswerten
	call ki			; Zeichen holen
	cp 'F'
	jr nz,proglp1		; F = Flip
	ld a,(flip)		; Wechsel zwischen 1 und 0
	or a
	jr nz,progflp1		; a=0?
	ld a,1			; a=1
	jr progflp2
progflp1:
	xor a			; a=0
progflp2:
	ld (flip),a
	ld (flipcnt),a
	ld (viewpage),a 	; 0,1
	call aktpage 		; =0 dann ruecksetzen
	ld a,'F'
proglp1:
	cp 'M' 			; M = Menue
	jr nz,proglp0
finalprg:			; Ende ausfuehrung
	xor a
	ld (flip),a
	ld (flip1),a 		; kein flip mehr
	ld a,0
	ld (viewpage),a
	call aktpage 		; zurueckschalten
	ret 
#ENDIF


; ENDE PROGRAMM STARTEN 
;------------------------------------------------------------------




;------------------------------------------------------------------
; HEXDUMP
; Verbesserung
;     "1234567890123456789012345678901234567890123456789012345678901234567890123456789012345"
;     "ADR   0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F   0123456789ABCDEF  CHKSUM"
;     "0000  00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00  ................  = 0000"

#IF optLANG=langDE
spmsg1:
	.word 0,240\	.byte 32h,0\	.text "Speicherinhalt"\	.byte 0
spmsg3:
	.word 0,220\	.byte 21h,0\	.text "+=vor  -=zurueck   R=Adr   M=Menue"\	.byte 0
spmsg4:
	.word 0,174\	.byte 11h,0\	.text "ADR   0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F   0123456789ABCDEF  SUMME"\	.byte 0
#ENDIF
#IF optLANG=langEN
spmsg1:
	.word 0,240\	.byte 32h,0\	.text "Hexdump"\		.byte 0
spmsg3:
	.word 0,220\	.byte 21h,0\	.text "+ = next  - = back  R = Addr   M = Menu"\	.byte 0
spmsg4:
	.word 0,174\	.byte 11h,0\	.text "ADDR  0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F   0123456789ABCDEF  CHKSUM"\	.byte 0
#ENDIF

speichan:			;speicherinhalte ansehen
	ld hl,spmsg1
	call textsetaus
	ld hl,spmsg4
	call textsetaus
	call getadr 		;nach hl wert holen ADR
	ld (fixadr),hl
	ld (startadr),hl
	jr c,dumpret		;wenn fehler ende

dumplp:
	call hexdump256		;Hexdump aufrufen
	ld hl,spmsg3		;Menue darstellen
	call textsetaus

	call ki 		;zeichen holen
	and 7fh
	cp 'M' 
	ret z			;M = ende Speicheransehen
	cp '+'
	jr nz,dumplp1		;+ = halbe seite weiter
	ld hl,(startadr)
	ld de,80h
	add hl,de
	ld (startadr),hl
	jr dumplp
dumplp1:
	cp '-'
	jr nz,dumplp2		;- = halbe seite zurck
	ld hl,(startadr)
	ld de,80h
	xor a
	sbc hl,de
	ld (startadr),hl
	jr dumplp
dumplp2:
	cp 'R'
	jr nz,dumplp		;R = Neue Adresse
	call getadr
	jr c,dumplp
	ld (fixadr),hl
	ld (startadr),hl
	jr dumplp		;Tastaturschleife

dumpret:
	ret


;parameter fixadr = start adresse marker
;	   startadr = startadr hexdump

hexdump256:
	ld hl,0 		;x=feste adresse 
	ld de,10*16 		;y=start wert
	ld a,11h 		;texthoehe
	call setausbuf

	ld hl,(startadr)	;Startadresse normieren
	ld a,l
	and 0f0h
	ld l,a			;Startadr auf 16er Grenze

	ld c,16			;Schleife 16 Zeilen  
hexrows:
	push bc			;Zhler sichern

	ld ix,ausbuf+6 		;ausgabeziel fuer prints
	call prthl 		;startadresse ausgeben
	call blank
	call blank

	ld b,16 		;16 HEX Werte
	call prtbytes		;Bytes ausgeben

	ld de,16		;Adresse wieder auf Anfang der Zeile
	xor a			;wegen ASCII ausgabe
	sbc hl,de 		;zurueck legen

	call blank		;Abstand
	call blank

	ld b,16			; Schleife 16 ASCII Zeichen
hexascii:
	ld a,(hl)		;Byte von (HL) lesen
	and 7fh			;check auf ASCII Bereich
	cp 7fh+1
	jr nc,hexnoasc
	cp 32
	jr nc,hexisasc		
hexnoasc:
	ld a,20h
hexisasc:
	call zeich 		;ausgeben
	inc hl 			;nchstes Byte
	djnz hexascii

	call blank		; Abstand
	call blank
	
	ld de,16		;Adresse wieder auf Anfang der Zeile
	xor a			;wegen Prfsumme
	sbc hl,de 		;zurueck legen

	ld de,0			;Pruefsumme
	ld b,16			;Schleife 16 Bytes addieren
hexpruef:
	ld a,(hl)		;Byte von (HL) lesen
	inc hl			;nchstes byte
	add a,e			;Checksumme bilden
	ld e,a
	jr nc,hexpruef1
	inc d
hexpruef1:
	djnz hexpruef
	
	push hl			;aktuelle Adresse sichern
	ld a,'='		;
	call zeich
	call blank
	ld h,d			;Prfsumme nach hl
	ld l,e
	call prthl		;und ausgeben

	ld hl,ausbuf		;Zeile ausgeben
	call textsetaus
	ld hl,(ausbuf+2)	;YPos verringern
	ld de,10
	xor a
	sbc hl,de 		;subtr
	ld (ausbuf+2),hl
	pop hl			;Adresse wiederherstellen
	
	pop bc			;Zhler wiederherstellen
	dec c			;nchste Zeile
	jp nz,hexrows
	ret

; ENDE HEXDUMP
;------------------------------------------------------------------


;------------------------------------------------------------------
; ALLGEMEINE UNTERPROGRAMME FR FUNKTIONEN

#IF optLANG=langDE
getadrmsg:	
	.word 0,190\	.byte 22h,0\	.text "Adr:"\	.byte 0
#ENDIF
#IF optLANG=langEN
getadrmsg:	
	.word 0,190\	.byte 22h,0\	.text "Addr:"\	.byte 0
#ENDIF

getadr:				;Eingabe einer Adresse
	ld hl,getadrmsg		;ADR:
	call textsetaus
	ld hl,68
	ld de,190
	ld a,22h
	ld b,30 		;30 zeichen max
	call textxy 		;holen des textes
	ld ix,linbuf+8 		;keine zuweisungen erlaubt
	call expr 		;carry = fehler dann MENUE
	ret

get3par:			;ix=textblock
	ld hl,10 		;bei fehler ret c
	ld de,180
	ld a,22h
	call textprint 		;ausgabe

	ld hl,150
	ld de,180
	ld a,22h
	ld b,30
	call textxy 		;eingabe text1 
	ld ix,linbuf+8
	call expr
	ld (startadr),hl 	;start
	ret c  			;fehler

	ld hl,150
	ld de,160
	ld a,22h
	ld b,30
	call textxy 		;eingabe text1 
	ld ix,linbuf+8
	call expr
	ld (startnext),hl 	;ende
	ret c  			;fehler

	ld hl,150
	ld de,140
	ld a,22h
	ld b,30
	call textxy 		;eingabe text1 
	xor a  			;no carry
	ret  			;ohne expr

; ENDE ALLGEMEIN
;------------------------------------------------------------------





;------------------------------------------------------------------
; FLOPPY / FLOMON START

#IF optJUMP=jumpFLOMON
; Rcksprung nach FLOMON oder Neustart GP
flomon:
	rst 00h			; Neustart
#ENDIF
#IF optJUMP=jumpFLOPPY
floppy:
	jp 001EH		; Floppy Verktor Flomon 3.2 ff
#ENDIF

; ENDE FLOPPY
;------------------------------------------------------------------






#IF optSAVE=saveUSB
;------------------------------------------------------------------
; LOW LEVEL ROUTINEN VDIP KOMMUNIKATION
; 
; ACHTUNG
;	Fr SPI Kommunikation muss das VDIP1 Modul eingestellt werden
;	J3 (ACBUS5): 	2-3 (pull down)
;       J4 (ACBUS6): 	1-2 (pull up)
; ANSCHLUSS
;	PIN 1		+5V
;	PIN 7/18	GND
;	PIN 6 (AD0)	SCLK
;	PIN 8 (AD1)	SDI
;	PIN 9 (AD2)	SDO	180pf gegen GND
;	PIN 10 (AD3)	CS
;	PIN 22 		RS#
; ACHTUNG
;	Eine Kommunikation klappt nur mit eingestecktem USB-Stick
;	Format: 	FAT oder FAT32
;	Sektorgre:	512 Byte
;	Clustergre:	bis 32 kByte
; STATUS REGISTER
;	Bit0: RXF#	0=Daten in FIFO schreiben mglich
;	Bit1: TXE#	0=Daten im FIFO vorhanden
;	Bit4: RXF IRQ Enable
;	Bit5: TXE IRQ Enable

spi_port	.equ	30h	; Port
spi_sdo		.equ	0	; SPI Ausgang
spi_sdi		.equ	1	; SPI Eingang
spi_sclk	.equ	2	; SPI Clock
vnc_rs		.equ	6	; VDIP1 Reset 
vnc_cs		.equ	7	; VDIP1 Chip Select
vnc_rxf		.equ	0	; Status Bit RXF#
vnc_txe		.equ	1	; Status Bit TXE#

CMD_DIR		.equ	01h	; List files
CMD_RD		.equ	04h	; Read whole file
CMD_WRF		.equ	08h	; Write bytes
CMD_OPW		.equ	09h	; Open for Write
CMD_CLF		.equ	0ah	; Close file
CMD_IDD		.equ	0fh	; Identify Disk Drive
CMD_SCS		.equ	10h	; Short Command Mode
CMD_DVL		.equ	2eh	; Disk Volume Label

; Initialisierung des VDIP1 Moduls
; 	RESET des Moduls, warten auf Prompt
;	Short Command Mode SCS aktivieren

vnc_reset:
	ld c,spi_port		; Check ob Hardware vorhanden
	in a,(c)
	res spi_sclk,a
	out (c),a
	in a,(c)
	bit spi_sclk,a
	ret nz			; Port nicht gefunden, ende

	ld a,(spi_port)		; RESET Sequence
	res vnc_cs,a
	res spi_sclk,a
	res spi_sdi,a
	res vnc_rs,a
	out (spi_port),a
	set vnc_rs,a
	out (spi_port),a
	call waitms100		; 100 ms warten

	call vnc_waitres	; Einschaltmeldung abholen
	ld b,100		; Max Wartezeit 10 Sekunden
vnc_reslp1:
	call waitms100		; in 100ms Anstnden testen
	call vnc_stat		; Status prfen
	bit vnc_txe,a		; Daten verfgbar?
	jr z,vnc_reset1		; Ja, Messages abholen
	djnz vnc_reslp1		; Sonst weiter warten
	jr vnc_reset2		; Kein Stick erkannt
	
vnc_reset1:	
	ld b,100		; max Durchlufe
vnc_reslp2:
	call vnc_waitres	; Meldung(en) berlesen
	jr nc,vnc_reset2		
	call waitms100
	djnz vnc_reslp2

vnc_reset2:			; FIFO leeren
	call vnc_clearfifo
	ld a,CMD_SCS
	call vnc_cmd
	call vnc_waitres	; Ergebnis abwarten
	
	ld a,0ffh		; Merken, dass initialisiert ist
	ld (vncflag),a
	ret



; Warten, bis Zeichen im FIFO vorhanden sind
vnc_waittxe:
	call vnc_stat		; Statusregister lesen
	bit vnc_txe,a		; TXE# testen
	jr nz,vnc_waittxe	; Weiter warten
	ret			; Zeichen vorhanden



; Alle Zeichen aus FIFO abholen und verwerfen
vnc_clearfifo:
	call vnc_read		; Zeichen abholen
	jr nc,vnc_clearfifo	; bis alle gelesen
	ret



; Auf Ergebnis eines Kommandos warten und abholen
; 	warten bis Zeichen im Buffer vorhanden
;	Fehlermeldungen sind immer 2 Char + <CR>
; 	Buffer leeren, dabei letzte zwei Zeichen merken
; Output
; 	CARRY		Set bei Fehler
; 	(VNCERR)	ASCII Fehlercode
; Register
;	DE		Fehlercodeverarbeitung

vnc_waitres:
	call vnc_waittxe	; Warten bis Daten verfgbar

vnc_waitres1:			; Daten im FIFO vorhanden
	call vnc_read		; Zeichen lesen
	jr c,vnc_waitresX	; Ende wenn Buffer leer
	cp '>'			; Prompt ?
	jr z,vnc_waitres2
	cp 0dh			; <CR> ?
	jr z,vnc_waitres3
	ld e,d			; 2 Zeichen merken
	ld d,a
	jr vnc_waitres1		; weiter lesen

vnc_waitres2:			; Prompt ">" erkannt
	call vnc_read		; <CR> lesen
	ld a,20h		; Fehlercode lschen
	ld (vncerr),a		
	ld (vncerr+1),a
	ret

vnc_waitres3:			; <CR> ohne Prompt erkannt
	call vnc_stat		; weitere Zeichen 
	bit vnc_txe,a		; im FIFO verfgbar?
	jr z,vnc_waitres1	; weiter einlesen
	scf			; Fehlerflag setzen

vnc_waitresX:			; kein Prompt, Buffer empty
	ld a,e			; Fehlercode setzen
	ld (vncerr),a
	ld a,d
	ld (vncerr+1),a
	ret			





; Kommando ausfhren ohne Parameter
vnc_cmd:
	call vnc_write		; Kommandobyte setzen
vnc_cr:
	ld a,0dh
	call vnc_write		; CR senden
	ret


; Prft, ob ein Datentrger erkannt wurde
; Sendet CR und wertet das Ergebnis aus
vnc_isdisk:
	call vnc_clearfifo
	call vnc_cr
	call vnc_waitres
	ret





; Low Level Kommunikation -------------------------------
spi_start:
	in e,(c)
	set vnc_cs,e
	set spi_sdi,e
	out (c),e
spi_clock:
	res spi_sclk,e
	out (c),e
	set spi_sclk,e
	out (c),e
	ret
spi_sdi0:
	res spi_sdi,e
	out (c),e
	jr spi_clock
spi_sdi1:
	set spi_sdi,e
	out (c),e
	jr spi_clock
spi_stop:
	res vnc_cs,e
	out (c),e
	jr spi_clock


; Lesen von VNC Status  -------------------------------
; Input
;	----
; Output
; 	ACCU:	Inhalt des Statusregisters
; Register
;	B:	Counter Bits
;	C:	Portadresse SPI
;	D:	Daten zusammensetzen
;	E:	Zustand Portbits (LowLevel)
;	HL:	Timeout Counter

vnc_stat:
	push bc			; Register sichern
	push de
	push hl
	ld c,spi_port
	call spi_start		; Startbedingung setzen
	call spi_sdi1		; R/W 1=Read
	call spi_sdi1		; ADDR 1=Status
	jr vncrdcnt		; weiter bei vnc_read

; Lesen von VNC Port -------------------------------
; Input
;	----
; Output
; 	ACCU:	gelesener Wert
;	CARRY:	Set bei Old Data oder Timeout
; Register
;	B:	Counter Bits
;	C:	Portadresse SPI
;	D:	Daten zusammensetzen
;	E:	Zustand Portbits (LowLevel)
;	HL:	Timeout Counter

vnc_read:
	push bc			; Register sichern
	push de
	push hl
	ld h,25			; Wiederholversuche bis Timeout
vncrdrep:
	ld c,spi_port
	call spi_start		; Startbedingung setzen
	call spi_sdi1		; R/W 1=Read
	call spi_sdi0		; ADDR 0=Daten
vncrdcnt:
	ld d,0			; Daten initialisieren
	ld b,8			; 8 bits lesen
vncrdlp:
	in a,(spi_port)		; Datenbit lesen
	and 1			; !!! Bitposition nicht variabel
	or d
	rlca
	ld d,a
	call spi_clock
	djnz vncrdlp		; bis alle Bits fertig
	rrc d

	in a,(spi_port)		; Status lesen
	call spi_clock
	call spi_stop		; Stopdedingung senden
	bit spi_sdo,a		; STATUS 0=new data 1=old data
	jr z,vncrdnew
	dec h			; Wiederholversuche
	jr nz,vncrdrep
	scf			; old data CARRY set
	jr vncrdexit		; Fertig
vncrdnew:
	scf			; new data CARRY clear
	ccf
vncrdexit:
	ld a,d			; Wert zurckholen
	pop hl
	pop de			; Register restaurieren
	pop bc
	ret	


; Schreiben auf VNC Port -----------------------------------
; Input
;	ACCU:	zu sendende Daten
; Output
; 	ACCU:	0=Accept FF=Reject
;	CARRY:	Set bei Buffer full
; Register
;	B:	Counter Bits
;	C:	Portadresse SPI
;	E:	Zustand Portbits (LowLevel)

vnc_write:
	push bc			; Register sichern
	push de
	ld c,spi_port
vncwrcnt:
	call spi_start		; Startbedingung setzen
	call spi_sdi0		; R/W 0=Write
	call spi_sdi0		; ADDR 0=Daten

	ld b,8			; 8 Bits schreiben
vncwrlp:
	rlca			; Bit 7 -> Carry
	jr nc,vncwr0
vncwr1: call spi_sdi1		; 1 schreiben
	jr vncwr2
vncwr0:	call spi_sdi0		; 0 schreiben
vncwr2:	djnz vncwrlp		; Bis alle ausgegeben

	in a,(spi_port)		; Status lesen
	call spi_clock
	call spi_stop		; Stopdedingung senden
	bit spi_sdo,a		; STATUS 0=accept 1=buffer full
	jr z,vncwrok
	ld a,0ffh
	scf			; old data CARRY set
	jr vncwrexit		; Fertig
vncwrok:
	xor a			; OK CARRY clear
vncwrexit:
	pop de			; Register restaurieren
	pop bc
	ret

; ENDE USB
;------------------------------------------------------------------

#ENDIF 







#IF optSAVE=saveUSB
;-----------------------------------------------------
; LADEN von USB

; Eingabe eines Dateinamens und Ablegen des Namens in VNCNAME
; Gemeinsam fr USBLOAD und USBSAVE
getname:
	ld hl,68
	ld de,190
	ld a,22h
	ld b,30 		; Breite des Feldes
	call textxy 		; Eingabefeld und Texteingabe
	ld ix,linbuf+8		; Adresse des Textes
	ld hl,vncname		; Adresse des Buffers
	ld b,12			; Max 12 Zeichen
getnamelp:
	ld a,(ix+0)		; Zeichen holen
	ld (hl),a		; in Buffer ablegen
	or a
	jr z,getnameend		; Endekennung?
	inc ix			; Pointer erhhen
	inc hl
	dec b			; Zeichenzhler
	jr nz,getnamelp		; Max Zeichen erreicht
getnameend:
	ld (hl),0		; Endekennung in Buffer
	ret

; Senden des Dateinamens aus VNCNAME an VDIP1 Modul
; Gemeinsam fr USBLOAD und USBSAVE
vnc_sendname:
	ld a,' '		; Trennung von CMD
	call vnc_write
	ld hl,vncname		; Adresse des Buffers
vnc_snlp: 
	ld a,(hl)		; Zeichen holen
	cp 0			; Endekennung ?
	jr z,vnc_sncr
	call vnc_write		; Zeichen senden
	inc hl			; Pointer erhhen
	jr vnc_snlp		; nchstes Zeichen
vnc_sncr:
	call vnc_cr		; CR senden
	call vnc_waittxe	; Warten auf Result
	ret


#IF optLANG=langDE
usblmsg1:
	.word 0,240\	.byte 32h,0\	.text "Laden USB"\	.byte 0
usblmsg2:
	.text "Name:"\	.byte 0ah\	.text "Adr:"\	.byte 0
#ENDIF
#IF optLANG=langEN
usblmsg1:
	.word 0,240\	.byte 32h,0\	.text "Load USB"\	.byte 0
usblmsg2:
	.text "File:"\	.byte 0ah\	.text "Addr:"\	.byte 0
#ENDIF

usbload:
	call usbcheck		; wenn notwendig initialisieren
	ld hl,usblmsg1		; Header des Screens
	call textsetaus
	call vnc_isdisk		; Datentrger vorhanden?
	ld de,200		; YPos fr Fehlermeldung
	jp c,usb_error

ul_getpar:
	ld ix,usblmsg2		; Adresse Menuedefiniton
	ld hl,0
	ld de,190
	ld a,22h
	call textprint
	call getname		; Dateiname abfragen

	ld hl,68
	ld de,170
	ld a,22h
	ld b,30
	call textxy 		; Adresse abfragen
	ld ix,linbuf+8
	call expr
	ld (startadr),hl 	; Adresse sichern
	ret c  			; bei Fehler zum Hauptmen
	
ul_load:
	call vnc_clearfifo	; Buffer lschen
	ld a,CMD_RD
	call vnc_write		; CMD Read whole file
	call vnc_sendname	; Name senden und warten

	ld hl,(startadr)	; Adresse holen
ul_read:
	call vnc_read		; Byte lesen
	jr c,ul_readend		; Carry = ende
	ld (hl),a		; Byte in Mem ablegen
	inc hl			; Pointer erhhen
	jr ul_read		; nchstes Byte

ul_readend:
	ret			; Zurck zum Hauptmen

;-----------------------------------------------------
; SPECHERN auf USB
; Titel ausgeben

#IF optLANG=langDE
usbsmsg1:
	.word 0,240\	.byte 32h,0\	.text "Speichern USB"\	.byte 0
usbsmsg2:
	.text "Name:"\	.byte 0ah\	.text "Adr:"\	.byte 0ah\	.text "Anz:"\	.byte 0
#ENDIF
#IF optLANG=langEN
usbsmsg1:
	.word 0,240\	.byte 32h,0\	.text "Save USB"\	.byte 0
usbsmsg2:
	.text "File:"\	.byte 0ah\	.text "Addr:"\	.byte 0ah\	.text "Len:"\	.byte 0
#ENDIF

usbsave:
	call usbcheck		; wenn notwendig initialisieren
	ld hl,usbsmsg1		; Header des Screens
	call textsetaus
	call vnc_isdisk		; Datentrger vorhanden?
	ld de,200		; YPos fr Fehlermedung
	jp c,usb_error

us_getpar:
	ld ix,usbsmsg2		; Adresse Menuedefiniton
	ld hl,0
	ld de,190
	ld a,22h
	call textprint
	call getname		; Dateiname abfragen

	ld hl,68
	ld de,170
	ld a,22h
	ld b,30
	call textxy 		; Adresse abfragen
	ld ix,linbuf+8
	call expr
	ld (startadr),hl 	; Adresse sichern
	ret c  			; bei Fehler zum Hauptmen

	ld hl,68
	ld de,150
	ld a,22h
	ld b,30
	call textxy 		; Lnge abfragen
	ld ix,linbuf+8
	call expr
	ld (startnext),hl 	; Anzahl sichern sichern
	ret c  			; bei Fehler zum Hauptmen

us_save:
	call vnc_clearfifo	; Buffer lschen
	ld a,CMD_OPW
	call vnc_write		; CMD Open for Write
	call vnc_sendname	; Name senden und warten
	call vnc_waitres
	jr c,us_saveerr

	ld a,CMD_WRF		; CMD Write File
	call vnc_write
	ld a,' '		; Trennzeichen
	call vnc_write
	xor a			; MSB zuerst
	call vnc_write		; 00h 00h
	call vnc_write
	ld bc,(startnext)	; lnge holen
	ld a,b			; MSB
	call vnc_write
	ld a,c			; LSB
	call vnc_write
	call vnc_cr		; CR senden

	ld hl,(startadr)	; Adresse holen
us_savelp:
	ld a,(hl)		; Byte holen 
	call vnc_write		; und senden
	inc hl			; incr Pointer 
	dec bc			; decr Counter
	ld a,b
	or c
	jr nz,us_savelp		; Bis alles ausgegeben

	call vnc_waitres	; Warten auf Result
	jr c,us_saveerr

	ld a,CMD_CLF
	call vnc_write		; CMD Close file
	call vnc_sendname	; Name senden und warten
	call vnc_waitres
	ret nc

us_saveerr:
	ld de,100		; YPos fr Fehlermeldung		
	jp usb_error



;-----------------------------------------------------
; USB INHALTSVERZEICHNIS
; 3 x 16 Files ausgeben, Spaltenpositionen 0, 168, 336
; Register
;	C	Zeilenzhler
;	B	Spaltenzhler
;	DE	YPOS
;	HL	XPOS
;	HL	Pointer fr Textsetaus

#IF optLANG=langDE
usbdmsg1:
	.word 0,240\	.byte 32h,0\	.text "USB Inhalt"\			.byte 0
usbdmsg2:
	.word 0,  0\	.byte 21h,0\	.text "cr=weiter   M=Menue"\		.byte 0
#ENDIF
#IF optLANG=langEN
usbdmsg1:
	.word 0,240\	.byte 32h,0\	.text "Directory"\			.byte 0
usbdmsg2:
	.word 0,  0\	.byte 21h,0\	.text "cr = next  M = Menu"\		.byte 0
#ENDIF


usbdir:
	call usbcheck		; wenn notwendig initialisieren

	ld hl,usbdmsg1		; Header des Screens
	call textsetaus
	call vnc_isdisk		; Datentrger vorhanden?
	ld de,200		; YPos fr Fehlermeldung
	jp c,usb_error

	ld hl,usbdmsg2		; Menue ausgeben
	call textsetaus

ud_dir:
	call vnc_clearfifo
	ld a,CMD_DIR		; DIR an VDIP senden
	call vnc_cmd
	call vnc_waittxe	; Warten auf Result
	call vnc_read		; initial <CR> einlesen

ud_npage:
	ld d,16			; 16 Zeilen
	ld ix,ausbuf+6		; Buffer Startadresse
ud_nrow:
	ld c,3			; 3 Spalten
ud_ncol:
	ld b,14			; 14 Zeichen pro Eintrag
	ld e,1			; Flag fr Ausgabe Zeichen
ud_nchar:
	ld a,e			; Flag checken
	or a
	jr z,ud_space		; Wenn Flag 0 dann Spaces ausgeben
	
	call vnc_read		; Zeichen lesen
	cp 0dh			; <cr> = Ende Eintrag
	jr nz,ud_outchar	; nicht <cr>, Zeichen ausgeben
	
	ld e,0			; Flag fr Ausgabe Spaces 
ud_space:	
	ld a,' '		; Space laden

ud_outchar:
	ld (ix+0),a		; Zeichen in Buffer ablegen
	inc ix			; Pointer erhhen
	djnz ud_nchar		; Bis 14 Zeichen ausgegeben sind

	dec c
	jr nz,ud_ncol		; Nchste Spalte

	ld (ix+0),0dh		; <cr> in Buffer
	inc ix
	dec d
	jr nz,ud_nrow		; Nchste Zeile

	ld (ix+0),0		; Endekennung setzen

	push de			; Ausdruck des Buffers
	ld hl,0
	ld de,200
	ld a,$21
	call printbuf
	pop de
	
ud_key:	call ki			; Keyboardabfrage
	cp 'M'
	jr z,ud_exit		; zurck zum Hauptmen
	cp 0dh
	jr nz,ud_key		; kein korrekter Key
ud_next:			
	call vnc_stat		; Nchste Seite
	bit vnc_txe,a		; noch Zeichen im Buffer?
	jr z,ud_npage		; wenn ja nchste Seite
	jr ud_dir		; sonst von vorn beginnen
ud_exit:
	call vnc_clearfifo	; Buffer leeren
	ret			; Zurck zum Hauptmen





; Allgemeine Fehlerausgabe USB
usberrtxt:
	#IF optLANG=langDE
	.text "Fehler: "\	.byte 0
	#ENDIF
	#IF optLANG=langEN
	.text "Error: "\	.byte 0
	#ENDIF

usb_error:
	call setpen	;%%% invers-fehler
	ld hl,ausbuf+6	; Ausgabebufer
	ld bc,usberrtxt	; Fehlertext bertragen
usb_err1:
	ld a,(bc)
	ld (hl),a
	or a
	jr z,usb_err2
	inc hl
	inc bc
	jr usb_err1
usb_err2:
	ld a,(vncerr)	; Lasterror bertragen
	ld (hl),a
	inc hl
	ld a,(vncerr+1)
	ld (hl),a
	inc hl
	xor a		; Endekennung
	ld (hl),a

	ld hl,0		; Xpos (Ypos als Pamameter)
	ld a,21h	; Size
	call printbuf	; Fehlerausgabe
	call ki		; Tastenabfrage
	ret


; ------------------------------------------------------
; Verzgerte Initialisierung fr schnelleren Start des GP
usbimsg1:
	#IF optLANG=langDE
	.word 0,240\	.byte 21h,0\	.text "Start USB ..."\		.byte 0
	#ENDIF
	#IF optLANG=langEN
	.word 0,240\	.byte 21h,0\	.text "Init USB ..."\		.byte 0
	#ENDIF

usbcheck:
	ld a,(vncflag)
	or a
	ret nz			; Inititalisiert, OK
	ld hl,usbimsg1
	call textsetaus
	call vnc_reset
	call clear		; Bildschirm lschen
	ret

; VDIP1 ENDE
;------------------------------------------------------------------
#ENDIF


;------------------------------------------------------------------
; INIT Systeminitialisierung

pruefe:	.byte $55,$aa,$01,$80 	;test speicherausfall

init:		
	xor a
	ld (synstate),a 	;state start

#IF optFLIP != autoNONE
	ld (flip1),a
	ld (flip),a 		;kein autoflip mode
#ENDIF

	;nur dann init der symbole wenn der check mit den vier 
	;pruefbytes versagt, dann mglicherweise ungueltig

	ld hl,pruefe		;pruefbytes im rom
	ld de,check		;pruefbytes in vars
	ld b,4  		;anzahl bytes
checkloop:
	ld a,(de)		;test (de) <> (hl)
	cp (hl)
	jr nz, initsym		;ungleich, Symbole initialisieren
	inc hl			;nchstes byte
	inc de
	djnz checkloop		;bis fertig
	jr inithard
	
initsym:			; Lschen der Symbole
	xor a
	ld (symtab),a 		;endezeichen ablegen
	ld hl,symtab
	ld (symptr),hl 		;freier platz symbole
	ld hl,0
	ld (symanz),hl 		;anzahl symbole = 0
	ld hl,pruefe		;pruefbytes nach vars
	ld de,check
	ld bc,4
	ldir  			;nun ist symtab gueltig

	ld hl,psw1sto 		;bereich loeschen
	ld de,psw1sto+1
	ld bc,lenpsw-1 
	ld (hl),0
	ldir  			;register auf 0

inithard:			; Hardware initialisieren
	ld a,7  		;alle GDP register loeschen
	call cmd
	xor a  			;set function
	call cmd
	ld a,2  		;pen down
	call cmd
	call clrall 		;alle Seiten loeschen

#IF optSAVE=saveCAS
	call casinit 		;Kassetten init
#ENDIF

#IF optSAVE=saveUSB
	xor a			;USB Init verzgern	
	ld (vncflag),a		;0=nicht initialisiert
#ENDIF

	ret

; Ende Initialisierung
;------------------------------------------------------------------


;------------------------------------------------------------------
; MENUEPAGE
;	Menueseite aus Versorgungsblcken fr TEXTAUS.
; Aufbau Versorgungsblcke
;	Word XPOS: 0-511
;	Word YPOS: 0-255
;	Byte SIZE: Bit4-7=Breite Bit0-3=Hhe
;	Byte ITAL: Schrge
;	Textblock: auszugebender Text 
;	Abschluss: $00
; Ende Tabelle
;	Abschluss: $FFFF
; Verwendete Buchstaben
;	ABcDEFGHIjkLMnOPqRSTuVwXYz
; Zeilen
; 	200 184 168 152 136 120 104 88  72  56  40  0
;	M   D   E   T       G   B   A   F       Y   
;	L   S   V       O   I       P   R       T
; Erweiiterung Version 3.1
; 	Menpunkte fr G = GOSI, B = BASIC und A = ASSEM

menuepage:

#IF optLANG=langDE
	; Titelzeile
	.word 0,240\ 	.byte $32,2\	.text "Grundprogramm 3.0"\	.byte 0
	
	; linke Spalte
	.word 0,200\	.byte $21,0\	.text "M = aendern MEM"\	.byte 0
	.word 0,184\	.byte $21,0\	.text "D = ansehen MEM"\	.byte 0
	.word 0,168\	.byte $21,0\	.text "E = starten PRG"\	.byte 0
	.word 0,152\	.byte $21,0\	.text "T = Einzelschritt"\	.byte 0
	#IF optGOSI = 1
	.word 0,120\	.byte $21,0\	.text "G = GOSI Start"\		.byte 0
	#ENDIF
	#IF optBASIC = 1
	.word 0,104\	.byte $21,0\	.text "B = BASIC Start"\	.byte 0
	#ENDIF
	#IF optEZASS = 1
	.word 0, 88\	.byte $21,0\	.text "A = ASSEM Start"\	.byte 0
	#ENDIF
	#IF optJUMP=jumpFLOMON
	.word 0, 72\	.byte $21,0\	.text "F = FLOMON Start"\	.byte 0
	#ENDIF
	#IF optJUMP=jumpFLOPPY
	.word 0, 72\	.byte $21,0\	.text "F = FLOPPY Boot"\	.byte 0
	#ENDIF
	.word 0, 40\	.byte $21,0\	.text "Y = Symbole"\		.byte 0

	; rechte spalte
	#IF optSAVE=saveCAS
	.word 256,200\	.byte $21,0\	.text "L = laden CAS"\		.byte 0
	.word 256,184\	.byte $21,0\	.text "S = speichern CAS"\	.byte 0
	.word 256,168\	.byte $21,0\	.text "V = pruefen CAS"\	.byte 0
	#ENDIF
	#IF optSAVE=saveUSB
	.word 256,200\	.byte $21,0\	.text "L = laden USB"\		.byte 0
	.word 256,184\	.byte $21,0\	.text "S = speichern USB"\	.byte 0
	.word 256,168\	.byte $21,0\	.text "V = USB Inhalt"\		.byte 0
	#ENDIF
	.word 256,136\	.byte $21,0\	.text "O = setzen I/O"\		.byte 0
	.word 256,120\	.byte $21,0\	.text "I = lesen I/O"\		.byte 0
	.word 256, 88\	.byte $21,0\	.text "P = prog. EPROM"\	.byte 0
	.word 256, 72\	.byte $21,0\	.text "R = lesen EPROM"\	.byte 0
	#IF optIncludeTest = 1
	.word 256, 40\	.byte $21,0\	.text "X = Test"\		.byte 0
	#ENDIF	

	; Fuzeile
	.word   0,  0\	.byte $21,0\	.text "(C) 2013 Andreas Rohmann    www.ndr-nkc.de"\	.byte 0
	; Tabellenende
	.word $FFFF
#ENDIF
#IF optLANG=langEN
	; Title
	.word 0,240\ 	.byte $32,2\	.text "Monitor 3.0"\		.byte 0
	; left column
	.word 0,200\	.byte $21,0\	.text "M = Edit Memory"\	.byte 0
	.word 0,184\	.byte $21,0\	.text "H = Show Hexdump"\	.byte 0
	.word 0,168\	.byte $21,0\	.text "E = Execute"\		.byte 0
	.word 0,152\	.byte $21,0\	.text "T = Trace"\		.byte 0
	#IF optGOSI = 1
	.word 0,120\	.byte $21,0\	.text "G = GOSI Start"\		.byte 0
	#ENDIF
	#IF optBASIC = 1
	.word 0,104\	.byte $21,0\	.text "B = BASIC Start"\	.byte 0
	#ENDIF
	#IF optEZASS = 1
	.word 0, 88\	.byte $21,0\	.text "A = EZASS Start"\	.byte 0
	#ENDIF
	#IF optJUMP=jumpFLOMON
	.word 0, 72\	.byte $21,0\	.text "F = FLOMON Start"\	.byte 0
	#ENDIF
	#IF optJUMP=jumpFLOPPY
	.word 0, 72\	.byte $21,0\	.text "F = FLOPPY Boot"\	.byte 0
	#ENDIF
	.word 0, 40\	.byte $21,0\	.text "Y = Show Symbols"\	.byte 0

	; right column
	#IF optSAVE=saveCAS
	.word 256,200\	.byte $21,0\	.text "L = Load CAS"\		.byte 0
	.word 256,184\	.byte $21,0\	.text "S = Save CAS"\		.byte 0
	.word 256,168\	.byte $21,0\	.text "V = Verify CAS"\		.byte 0
	#ENDIF
	#IF optSAVE=saveUSB
	.word 256,200\	.byte $21,0\	.text "L = Load USB"\		.byte 0
	.word 256,184\	.byte $21,0\	.text "S = Save USB"\		.byte 0
	.word 256,168\	.byte $21,0\	.text "D = Directory"\		.byte 0
	#ENDIF
	.word 256,136\	.byte $21,0\	.text "O = Set Port"\		.byte 0
	.word 256,120\	.byte $21,0\	.text "G = Get Port"\		.byte 0
	.word 256, 88\	.byte $21,0\	.text "P = Prog EPROM"\		.byte 0
	.word 256, 72\	.byte $21,0\	.text "R = Read EPROM"\		.byte 0
	#IF optIncludeTest = 1
	.word 256, 40\	.byte $21,0\	.text "X = Test"\		.byte 0
	#ENDIF	
	; Fuzeile
	.word   0,  0\	.byte $21,0\	.text "(C) 2013 Andreas Rohmann    www.ndr-nkc.de"\	.byte 0
	; Tabellenende
	.word $FFFF
#ENDIF

;------------------------------------------------------------------
; KEYTABLE
;	Tastencodes und Sprungadressen in Tabellenform
;	jeweils 1 Byte KeyCode und 2 Byte Adresse
;	Abschlussbyte 00h


keytable:	
	.byte 'M'	; MODIFY
	.word progmod
	.byte 'E'	; EXECUTE
	.word progstart
	#IF optJUMP=jumpFLOMON
		.byte 'F'	; FLOMON
		.word flomon
	#ENDIF
	#IF optJUMP=jumpFLOPPY
		.byte 'F'	; FLOMON
		.word floppy
	#ENDIF
	#IF optLANG=langDE
		.byte 'D'	; DISPLAY
	#ENDIF
	#IF optLANG=langEN
		.byte 'H'	; HEXDUMP
	#ENDIF
	.word speichan
	.byte 'Y'	; SYMBOLS
	.word symaus
	#IF optGOSI = 1
		.byte 'G'	; GOSI Start
		.word $2000
	#ENDIF
	#IF optBASIC = 1
		.byte 'B'	; BASIC Start
		.word $4000
	#ENDIF
	#IF optEZASS = 1
		.byte 'A'	; EZASS Start
		.word $6000
	#ENDIF
	#IF optSAVE=saveCAS
		.byte 'L'	; LOAD CAS
		.word ladcas
		.byte 'S'	; SAVE CAS
		.word speichcas
		.byte 'V'	; VERIFY CAS
		.word pruefcas
	#ENDIF
	#IF optSAVE=saveUSB
		.byte 'L'	; LOAD USB
		.word usbload
		.byte 'S'	; SAVE USB
		.word usbsave
		#IF optLANG=langDE
			.byte 'V'	; USB DIR
		#ENDIF
		#IF optLANG=langEN
			.byte 'D'	; USB DIR
		#ENDIF
		.word usbdir
	#ENDIF
	#IF optLANG=langDE
		.byte 'I'	; IN IO
	#ENDIF
	#IF optLANG=langEN
		.byte 'G'	; GET IO
	#ENDIF
	.word ioread
	.byte 'O'	; OUT IO
	.word iowrite
	.byte 'T'	; TRACE
	.word stepstart
	.byte 'P'	; PROG PROM
	.word promwrite
	.byte 'R'	; READ PROM
	.word promread
	#IF optIncludeTest = 1
		.byte 'X'	; TEST PROGRAM
		.word testprog
	#ENDIF
	.byte 0


#IF optIncludeTest = 1
#INCLUDE MCP3TEST.INC
#ENDIF


;------------------------------------------------------------------
; Einsprung Hauptschleife
start:
	ld sp,stack 	;Stackpointer definieren
	call init 	;loeschen des Bildschirm
	call savegdp 	;retten fuer single step alle gdp-register

	push hl		;Wenn zuviele RET, dann HALT
	ld hl,syserr	;Adresse des HALT-Befehls am Ende des ROMs
	ex (sp),hl	;auf den Stack legen

restart:
	call clrall 	;loeschen aller Seiten
	ld hl,menuepage	;Aufbau neues Menue
	call textmulti
	
keyloop:
	call ki		;Tastenwert nach Accu
	ld c,a		;nach register c sichern
	ld hl,keytable	;Tabelle der Keycodes und Adressen
tabloop:
	ld a,(hl)	;keycode aus tabelle lesen
	cp 0		;ende-code?
	jr z,keyloop	;neue taste holen
	cp c		;mit Tastenwert vergleichen
	jr z,keyfound	;gefunden, Adresse anspringen
	inc hl		;Zeiger auf nchsten code
	inc hl
	inc hl
	jr tabloop	;Tabelle abarbeiten
keyfound:
	call clrall	;loeschen aller Seiten
	inc hl		;Pointer auf Adresse
	ld e,(hl)	;Adresse auslesen
	inc hl
	ld d,(hl)
	ld h,d		; nach hl
	ld l,e
	push hl		;hl sichern auf stack
	ld hl,restart	;rcksprungadresse nach hl
	ex (sp),hl	;und tauschen (ret -> restart)
	jp (hl)		;JP nach Routine
			
; ENDE Hauptschleife
;------------------------------------------------------------------

#IF $ < basis + $1FC0
	#IF optIncludeOpts=1
		.org basis + $1FC0
		#IF optBASE=base0000
			.text "EGRUND31 BASIS=0000 "
		#ENDIF
		#IF optBASE=base2000
			.text "EGRUND31 BASIS=2000 "
		#ENDIF
		#IF optLANG=langDE
			.text "langDE "
		#ENDIF
		#IF optLANG=langEN
			.text "langEN "
		#ENDIF
		#IF optSAVE=saveNONE
			.text "saveNONE "
		#ENDIF
		#IF optSAVE=saveCAS
			.text "saveCAS "
		#ENDIF
		#IF optSAVE=saveUSB
			.text "saveUSB "
		#ENDIF
		#IF optJUMP=jumpNONE
			.text "jumpNONE "
		#ENDIF
		#IF optJUMP=jumpFLOMON
			.text "jumpFLOMON "
		#ENDIF
		#IF optJUMP=jumpFLOPPY
			.text "jumpFLOPPY "
		#ENDIF
		#IF optFLIP=autoNONE
			.text "autoNONE"
		#ENDIF
		#IF optFLIP=autoEXEC
			.text "autoEXEC"
		#ENDIF
		#IF optFLIP=autoDRAW
			.text "autoDRAW"
		#ENDIF
		#IF optFLIP=autoBOTH
			.text "autoBOTH"
		#ENDIF
	#ENDIF
#ENDIF

	.org	basis + $1FFF
syserr:	
	halt  	;system error


		;***********************************
		;* Ram Speicher STD 8000h          *    
		;***********************************

		.org 8000h	; RAM START

userram 	.equ $+800h 	; 2K Reserve von hier an
				; dort Benutzerdaten oder Programme

speichend 	.equ $+0fffh 	; Ende des Speicherbereichs SBCII


nmiloc:		.byte 0,0,0 	; hier Sprung eintragen
intloc:		.byte 0,0,0 	; um Interrupts zu verwenden

pcsto:		.word 0

psw1sto:	.word 0 	;start
bcsto:		.word 0
desto:		.word 0
hlsto:		.word 0
psw2sto:	.word 0
bc2sto:		.word 0
de2sto:		.word 0
hl2sto:		.word 0
rxsto:		.word 0
rysto:		.word 0
usersp:		.word 0
iregsto:	.byte 0
rregsto:	.byte 0

lenpsw 		.equ $-psw1sto

gdpreg:		.block 16 	;gdp-register stand fuer single step


syssp:		.word 0  	;temp merken

modber:		.byte 0,0,0,0   ;fuer execbereich step
modspg:		.byte 0,0,0     ;fuerrueck

newx:		.word 0  	;temp speicher
newy:		.word 0  	;in drawto
oldx:		.word 0
oldy:		.word 0
dx:		.word 0
dy:		.word 0
sign:		.byte 0  	;vorzeichenmerker arith etc temp
flip1:		.byte 0  	;flip count 0=neutral
flip1cnt:	.byte 0 	;zaehler aktuell 4 seiten
flip:		.byte 0  	;flip count 0=neutral
flipcnt:	.byte 0 	;2 seiten

synstate:	.byte 0 	;synchron Zustand
synccnt:	.byte 0 	;timer zaehler 20ms

lastsym:	.byte 0 	;temp in textein last symbol
txtpoi:		.word 0  	;temp pointer in linbuf

merkcas:	.byte 0 	;temp fuer cassette
merkzeich:	.byte 0 	;temp fuer progmod

vzsto:		.byte 0		; sin cos, auch quickprom loop count

xkoor:		.word 0		;fr Textausgabe
ykoor:		.word 0		;fr Textausgabe

sitemp:		.word 0		;fr sinus, cosinus

first:		.byte 0 	;grap 1=first
turx:		.word 0
tury:		.word 0
turphi:		.word 0
tur1x:		.word 0
tur1y:		.word 0
tur1phi:	.word 0
turdo:		.byte 0
teilflag:	.byte 0 	;1=teilen durch 2 zus.

viewpage:	.byte 0 	;0,1,2,3 page on view
wrtpage:	.byte 0 	;0,1,2,3 write page

		; TRACE

symtyp:		.byte 0  	;nach expr aufruf gueltig
aktpc:		.word 0  	;zaehler pc = '.' bei modify etc.

startold:	.word 0 	;prev ausgabe
startadr:	.word 0 	;fuer speichaus
startnext:	.word 0 	;next ausgabe
fixadr:		.word 0  	;fuer speichaus

zeigsy:		.word 0  	;temp var getsymbol
zeigqu:		.word 0  	;temp
susymind:	.word 0 	;index merker fuer suchesymbol

		; SPI & USB

vncflag:	.byte 0		;0=nicht initialisiert, ff=initialisiert
vncerr:		.word 0		;Fehlercode VDIP1 2 Char ASCII
vncname:	.block 13	;Zwischenspeicher Filename

		; BUFFER

ausbuf:		.word 0,0 	;ausgabebuffer 16 Zeilen 85 Zeichen
		.byte 0,0
		.block 16*86

linbuf:		.word 0,0	;eingabebuffer 85 Char 
		.byte 0,0
		.byte 0,0
		.block 86 	

		; STACK

		.block 150	;stack wchst nach unten
stack:		.byte 0		;oberster Stack-Eintrag

		; SYMBOLE

		;+++++ bereich wird bei CAS schreiben gerettet
symanz:		.word 0 	;anzahl symbole in tabelle
symptr:		.word 0 	;pointer auf naechsten freien platz

check:		.byte 0,0,0,0 	;vergleichen ob power on

symtab:		.byte 0 	;offenes ende SYMBOLTABELLE
		.block 200
		;+++++ ende bereich  end von symptr abhaengig
		
	.end start1

